/* $Id: common.js 5 2006-11-27 06:25:58Z troyronda $ */

/* iTrustPage
 * Copyright (c) 2006 Troy Ronda and the University of Toronto.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */


// This should become an XPCOM service at some-point
// Along with: a global whitelist and cache

var iTrustPageGoogleList = {
   load: function (){
	   this.GoogleList = new Object();
	   
      this.GoogleList["google.biz"]=1;
      this.GoogleList["google.com"]=1;
      this.GoogleList["google.info"]=1;
      this.GoogleList["google.net"]=1;
      this.GoogleList["google.org"]=1;
      this.GoogleList["google.us"]=1;
      this.GoogleList["google.ws"]=1;
      this.GoogleList["google.dk"]=1;
      this.GoogleList["google.se"]=1;
      this.GoogleList["google.co.nz"]=1;
      this.GoogleList["google.ca"]=1;
      this.GoogleList["google.cn"]=1;
      this.GoogleList["google.com.pr"]=1;
      this.GoogleList["google.com.ca"]=1;
      this.GoogleList["google.com.ch"]=1;
      this.GoogleList["google.fi"]=1;
      this.GoogleList["google.co.in"]=1;
      this.GoogleList["google.co.uk"]=1;
      this.GoogleList["google.lv"]=1;
      this.GoogleList["google.co.hu"]=1;
      this.GoogleList["google.lk"]=1;
      this.GoogleList["google.com.au"]=1;
      this.GoogleList["google.ru"]=1;
      this.GoogleList["google.nl"]=1;
      this.GoogleList["google.be"]=1;
      this.GoogleList["google.de"]=1;
      this.GoogleList["google.ro"]=1;
      this.GoogleList["google.kz"]=1;
      this.GoogleList["google.by"]=1;
      this.GoogleList["google.no"]=1;
      this.GoogleList["google.pl"]=1;
      this.GoogleList["google.com.pl"]=1;
      this.GoogleList["google.es"]=1;
      this.GoogleList["google.pt"]=1;
      this.GoogleList["google.com.br"]=1;
      this.GoogleList["google.vc"]=1;
      this.GoogleList["google.co.za"]=1;
      this.GoogleList["google.tm"]=1;
      this.GoogleList["google.com.my"]=1;
      this.GoogleList["google.bg"]=1;
      this.GoogleList["google.co.jp"]=1;
      this.GoogleList["google.ie"]=1;
      this.GoogleList["google.co.ck"]=1;
      this.GoogleList["google.com.mx"]=1;
      this.GoogleList["google.com.om"]=1;
      this.GoogleList["google.fr"]=1;
      this.GoogleList["google.mu"]=1;
      this.GoogleList["google.com.ph"]=1;
      this.GoogleList["google.com.jm"]=1;	 		
 }
};

var iTrustPageCommon = {
  utilsLCS: function(a,b){
    var len;
    var i;
    
    if (!a.length || a.length == 0)
       return 0;
    if (!b.length || b.length == 0)
       return 0;
    
    if (a.length > b.length)
       len = b.length;
    else
       len = a.length;
       
             
    for (i=0;i<len;++i){
	   if (a[a.length-i-1] != b[b.length-i-1])
	      return i;
    } 	  	  
    return len;
	  
  },
  
  utilsStipDomain: function (a){
     // strip www from both
     if (a.substr(0,3) == 'www'){
	    if (a[3] == '.')
	       return a.substring(4,a.length);
	    if (a[4] == '.')
	       return a.substring(5,a.length);	     
     }    
     
     return a;
  },
  
  utilsIsSameDomain: function (a,b){
	 var lcs;
//	 alert ("testing "+a);
	 
     if (a == "" || b == "")
        return false;
	    
     a = this.utilsStipDomain(a);        
     b = this.utilsStipDomain(b);                
//     alert (a + ": " + b);
     
     lcs = this.utilsLCS(a,b);     
     
     // check if one string is subsumed by the other string
     if (a.length == lcs){
	     // fix for the chance that the next character matches.
        if (b.substr(b.length-a.length-1,1) == ".")
           return true;        
     }

        
     if (b.length == lcs){
        if (a.substr(a.length-b.length-1,1) == ".")
           return true;        
        return true;      
     }  

     return false;     	  

//     return (a == b);
  }	,
  
  utilsExtractPath: function (a){	  
     var trailingSlash = a.lastIndexOf('/');
     if (trailingSlash == -1)
        return a; // no /!
     else
        return a.substring(0,   trailingSlash );        	  
  }
  
  
}

function iTrustPageCloneObject(what) {
    for (i in what) {
//        if (typeof what[i] == 'object') {
//            this[i] = new iTrustPageCloneObject(what[i]);
//        }
//        else
            this[i] = what[i];
    }
}


var iTrustPageWhitelist = {
whitelist:null,

init: function(){
   this.load();
},
load: function () {
   this.whitelist = new Array ();

   if( !iTrustPageMain.prefs.prefHasUserValue( "whitelist" ) ) {
  	   whiteListString = "";
  	   iTrustPageMain.prefs.setCharPref( "whitelist", whiteListString );
   }
	
	whiteListString = iTrustPageMain.prefs.getCharPref( "whitelist" );
  	var sites = whiteListString.split( ' ' );
   for( var i = 0; i < sites.length; i++ ){
     	if( sites[i].length > 0 ){
      	this.whitelist.push( sites[i] );
     	}
   }
   
   this.whitelist = this.whitelist.sort();
},
save: function () {
   var whiteListString = "";
   for( var i = 0; i < this.whitelist.length; i++ ){
      whiteListString += this.whitelist[i]+" ";      
   }
	iTrustPageMain.prefs.setCharPref( "whitelist", whiteListString );
},
addUri:function (uri){
   if (this.isUriInWhiteList (uri)){return;}

   this.whitelist.push (encodeURI(uri));    
   this.whitelist = this.whitelist.sort();
   this.save();
},
isUriInWhiteList:function (uri){
   var encodedURI = encodeURI(uri);

   for( var i = 0; i < this.whitelist.length; i++ ){   
      if (this.whitelist[i] == encodedURI){return true;}
   }
   
   return false;
}
}


