/* $Id: overlay.js 19 2007-02-01 03:19:43Z troyronda $ */

/* iTrustPage
 * Copyright (c) 2006 Troy Ronda and the University of Toronto.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */            


var iTrustPageMain = {   
   prefs: null, 
   
   debugLevel: 0,
   viewStausBarDelay:20,
   
   updateCheckInterval: 24*60*60*1000,
   cacheTime: 14400*60*1000,
   cacheFormTime: 144000*60*1000,
   cacheManualTime: 525948*60*1000,
   logSendAuto: true,
   checkOnPageLoad: false,
   checkOnInputFocus: false,  
   checkOnlyPagesWithInputs: false,
   checkOnKeyboardEvent: true,
   reportUseGooglePageRank: false,
   reportUseTrustWatch: false,
   viewShowStausBar: true,
   notificationPersist: false,
//   lastURI: "",
//   lastDomain: "",
   
   blockAllowBypass: true,
   blockAllowSubdomains: true,
   blockPathMustMatch: false,
   checkAllObjects: false,
   checkNewBookmarks: true,
   whitelistOnBookmark: true,
   reportUseiTrustPage: false,
   blockKeyThreshold: 1,
   enableLogging: true,
   
   reportPageRankThreshold: 5,
   reportPrefetching: true,
   
   enableBlockExtraInformation: false,
   enableBlockPrefetch: false,
   
   logUrl: "http://flanders3.slup.cs.toronto.edu/cgi-bin/itrustpage/rcvlog3.cgi",
    
   ////////////////////////// 
   // Version Information
   versionName: "3.0",
   versionMajorNumber: 3,
   versionMinorNumber: 0,
   versionPatchNumber: 0,/*4,*/
   versionPatchNumberString: "$Rev: 495 $", 
   versionDate: "$Date: 2006-10-23 13:43:52 -0600 (Mon, 23 Oct 2006) $",
   
   // Initialize the extension  
   startup: function() {
     // Register to receive notifications of preference changes
    // alert ("overlay startup");
     
     this.versionPatchNumberString = (this.versionPatchNumberString.substr(6,this.versionPatchNumberString.length-6-1));
     this.versionPatchNumber = parseInt(this.versionPatchNumberString,10);
     
     this.prefs = Components.classes["@mozilla.org/preferences-service;1"]
         .getService(Components.interfaces.nsIPrefService)
         .getBranch("itrustpage.");
     this.prefs.QueryInterface(Components.interfaces.nsIPrefBranch2);
     this.prefs.addObserver("", this, false); 
     
     /*
     this.checkOnPageLoad = this.prefs.getBoolPref("checkOnPageLoad");
     this.checkOnInputFocus = this.prefs.getBoolPref("checkOnInputFocus");
     this.checkOnlyPagesWithInputs = this.prefs.getBoolPref("checkOnlyPagesWithInputs");
     */

     /*
     this.checkOnKeyboardEvent = this.prefs.getBoolPref("checkOnKeyboardEvent");
     this.reportUseGooglePageRank = this.prefs.getBoolPref("reportUseGooglePageRank");
     this.reportUseTrustWatch = this.prefs.getBoolPref("reportUseTrustWatch");
     */
     
     //this.viewShowStausBar = this.prefs.getBoolPref("viewShowStausBar");
     //this.viewStausBarDelay = this.prefs.getIntPref("viewStausBarDelay");
     //this.debugLevel = this.prefs.getIntPref("debugLevel");

//     this.lastURI = this.prefs.getCharPref("lastURI");
//     this.lastDomain = this.prefs.getCharPref("lastDomain");

     /*
     this.blockAllowBypass = this.prefs.getBoolPref("blockAllowBypass");
     this.blockAllowSubdomains = this.prefs.getBoolPref("blockAllowSubdomains");
     this.blockPathMustMatch = this.prefs.getBoolPref("blockPathMustMatch");
     this.checkAllObjects = this.prefs.getBoolPref("checkAllObjects");
     this.checkNewBookmarks = this.prefs.getBoolPref("checkNewBookmarks");
     this.whitelistOnBookmark = this.prefs.getBoolPref("whitelistOnBookmark");
     this.reportUseiTrustPage = this.prefs.getBoolPref("reportUseiTrustPage");
     */
     
     /*
     this.enableBlockExtraInformation = this.prefs.getBoolPref("enableBlockExtraInformation");     
     */  
       
     /* 
     this.blockKeyThreshold = this.prefs.getIntPref("blockKeyThreshold");
     */
     
     /*
     this.reportPageRankThreshold = this.prefs.getIntPref("reportPageRankThreshold");
      */
     
     this.updateCheckInterval = Number(this.prefs.getCharPref("updateCheckInterval"))*60*60*1000;
     
     /*
     this.cacheCleanThreshold      =  Number(this.prefs.getCharPref("cacheTime"))*60*1000;
     this.cacheCleanThresholdForms =  Number(this.prefs.getCharPref("cacheFormTime"))*60*1000;
     this.cacheCleanThresholdManual = Number(this.prefs.getCharPref("cacheManualTime"))*60*1000;
     */
     
     this.prefs.setCharPref("versionName",this.versionName);
     this.lastUpdateTime = new Date();
     this.lastUpdateTime.setTime(this.prefs.getCharPref("updateLastCheck"));
     
     this.logSendLast = new Date();
     this.logSendLast.setTime(this.prefs.getCharPref("logSendLast"));
//     this.logSendAuto = this.prefs.getBoolPref("logSendAuto");    
     this.logSendAuto = true;
     iTrustPageMain.logSending = false;
         
     // get install date
     this.dateInstall = this.prefs.getCharPref("dateInstall");
     if (this.dateInstall == "0"){
        var updateTime = Date.now();	    	   
        this.prefs.setCharPref("dateInstall",updateTime.valueOf());
        this.dateInstall = this.prefs.getCharPref("dateInstall");
     }       
     this.dateInstall2 = this.prefs.getCharPref("dateInstall2");
     if (this.dateInstall2 == "0"){
        var updateTime = Date.now();	    	   
        this.prefs.setCharPref("dateInstall2",updateTime.valueOf());
        this.dateInstall2 = this.prefs.getCharPref("dateInstall2");
     }    
       
     this.dateInstall3 = this.prefs.getCharPref("dateInstall3");
     if (this.dateInstall3 == "0"){
        var updateTime = Date.now();	    	   
        this.prefs.setCharPref("dateInstall3",updateTime.valueOf());
        this.dateInstall3 = this.prefs.getCharPref("dateInstall3");
     }       

     try {   
        this.versionSplashMajor=0;
        this.versionSplashMinor=0;
        this.versionSplashPatch=0;
        this.dateSplash3 = "0";
        
        this.versionSplashMajor = this.prefs.getIntPref("versionSplashMajor");
        this.versionSplashMinor = this.prefs.getIntPref("versionSplashMinor");
        this.versionSplashPatch = this.prefs.getIntPref("versionSplashPatch");   
        this.dateSplash3 = this.prefs.getCharPref("dateSplash3");
     }catch (err){}
     
     
     if (this.dateSplash3 == "0" 
         || (this.versionSplashMajor < this.versionMajorNumber)
         || (this.versionSplashMinor < this.versionMinorNumber)
         || (this.versionSplashPatch < this.versionPatchNumber)
     
     ){
        window.setTimeout(
            function () {
             try {   
            var querystring = "http://www.cs.toronto.edu/~ronda/itrustpage/splash3.html?install"+
                       "&versionMajorNumber="+iTrustPageMain.versionMajorNumber+
                       "&versionMinorNumber="+iTrustPageMain.versionMinorNumber+
                       "&versionPatchNumber="+iTrustPageMain.versionPatchNumber
                       ;
                                
            var newTab = getBrowser().addTab(querystring);        
            //getBrowser().tabContainer.selectedIndex = 1;
            getBrowser().selectedTab = newTab;
             }catch (err){}
        },1000);
        
        var updateTime = Date.now();	    	   
        this.prefs.setCharPref("dateSplash3",updateTime.valueOf());
        //this.dateSplash3 = this.prefs.getCharPref("dateSplash3");
                
        this.prefs.setIntPref("versionSplashMajor",this.versionMajorNumber);
        this.prefs.setIntPref("versionSplashMinor",this.versionMinorNumber);
        this.prefs.setIntPref("versionSplashPatch",this.versionPatchNumber);
               
     }       


        //this.prefs.setCharPref("dateSplash3","0");
     
     //alert ("before id");

     //this.prefs.setCharPref("userid","0");
     this.userid = this.prefs.getCharPref("userid");
     //alert ("before id2");
     if (this.userid == "0"){
        var updateTime = Date.now();
        
        //alert ("time: "+updateTime);
        
        var Cc = Components.classes;
	    var Ci = Components.interfaces;
     	var dp = Cc["@mozilla.org/network/dns-service;1"];
     	//alert (dp);
	    var nsDNSService = dp.createInstance(Ci.nsIDNSService);
	    
	    //var nsDNSService = Components.classes["@mozilla.org/network/dns-service;1"]
        //             .createInstance(Components.interfaces.nsIDNSService);
                     
        //alert(nsDNSService);
        var DNSHostName = nsDNSService.myHostName;
        //alert (DNSHostName);
        //var DNSRecord=nsDNSService.resolve(DNSHostName, true);
        
        //alert (DNSRecord);
        //var ipStr = DNSRecord.getNextAddrAsString ();
        
        //alert ("ipStr: "+DNSHostName+ipStr);
        
        var key = updateTime.valueOf()+DNSHostName/*+ipStr*/;
        //alert ("key: "+key);
        
        var hash_key = iTrustPage_sha2.hex_sha256(key);
        //alert ("hash_key: "+hash_key);
                	    	   
        this.prefs.setCharPref("userid",hash_key);
        this.userid = this.prefs.getCharPref("userid");
     }       
     //alert (this.userid);
     
     ///////////////
     // open data service
     var hiddenWindow = Components.classes["@mozilla.org/appshell/appShellService;1"]
         .getService(Components.interfaces.nsIAppShellService)
         .hiddenDOMWindow;
     
     this.DataService   = hiddenWindow.iTrustPageDataService;
     if (!this.DataService){
        hiddenWindow.Components.classes["@mozilla.org/moz/jssubscript-loader;1"]
         .getService(Components.interfaces.mozIJSSubScriptLoader)
         .loadSubScript("chrome://itrustpage/content/common.js");    	     

        hiddenWindow.Components.classes["@mozilla.org/moz/jssubscript-loader;1"]
         .getService(Components.interfaces.mozIJSSubScriptLoader)
         .loadSubScript("chrome://itrustpage/content/trustDataService.js");    	                      
         
        this.DataService   = hiddenWindow.iTrustPageDataService;
        //this.DataService.startup();
     }
     if (!this.DataService){
	    alert("Your version of Firefox does not support hidden window data services");    
     }
     
     
     ////////////////     
     
     ///////////////
     // open log
     iTrustPageLog.logStartup();
     ///////////////
 
     ///////////////
     // open cache
     iTrustPageCache.cacheStartup();
     ///////////////
        
     //     alert ("done cache startup");

     
     this.enableLogging = this.prefs.getBoolPref("enableLogging");
     //this.reportPrefetching = this.prefs.getBoolPref("reportPrefetching");

     this.refreshInformation();    
     window.setInterval(this.refreshInformation, 10*60*1000);  

     // var b = getBrowser();     
     // var message = b.getMessageForBrowser(b.selectedBrowser, "bottom");
     // message.addEventListener("mousedown",this.notificationEvent,true);
     //promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"] 
     //                  .getService(Components.interfaces.nsIPromptService);
     //promptService.alert(this.window,"title","Hello");
    
     iTrustPageWhitelist.init();
     iTrustPageInitBookmarkListener();     
     
     // check for update
     iTrustPageMain.doUpdateQuery(false);  
     
     // check for log-send       
     iTrustPageMain.doLogSendAuto();  
     
/*     
     // move overlay if using firefox 1.5
	 // give it an id attribute called 'newSpan'
     var overlay_xul = document.getElementById("itrustpage-trustblock-box");
     var mainwindow_xul = document.getElementById("main-window");
     var browser1_xul = document.getElementById("browser");
     var browser2_xul = document.getElementById("browser-stack");

	    //alert (mainwindow_xul);
	 if (browser2_xul){
	     alert ("new firefox");
	    mainwindow_xul.removeChild(overlay_xul);
	    browser2_xul.parentNode.insertBefore(overlay_xul,browser2_xul);    	     		 
     }
     else if (!browser2_xul && browser1_xul){
	     alert ("old firefox");
	    // move overlay xul
//	    mainwindow_xul.removeChild(overlay_xul);
//	    mainwindow_xul.insertBefore(overlay_xul,browser1_xul);    	     
     }
  */    

         // ** DISABLE PageRank FUNCTIONS **
         this.reportUseGooglePageRank=false;         
         // ** DISABLE TRUSTWATCH FUNCTIONS **
         this.reportUseTrustWatch=false;
         
     //    alert ("done overlay load");
  
   },
   shutdown: function() {
      if (this.prefs)
        this.prefs.removeObserver("", this);
        
      iTrustPageCleanupBookmarkListener();  

     ///////////////
     // close cache
     iTrustPageCache.cacheStartup();
     ///////////////
            
     ///////////////
     // close log
     iTrustPageLog.logShutdown();
     ///////////////

     if (iTrustPageMain.logSending){
        iTrustPageMain.prefs.setCharPref("logSendLast","0"); // force send on next load
     }
      
   },
   onUpdateMenuCommand: function (ev){
      iTrustPageMain.doUpdateQuery(true)
   },
   doUpdateQuery: function (force){
     var updateElapsed = Date.now() - this.lastUpdateTime;	
     
     iTrustPageMain.autoUpdateQuery = false;
     if (!force){  
//     if (updateElapsed < 60*1000) return; /* one minute */
//     if (updateElapsed < 60*60*1000) return; /* one hour */
       if (updateElapsed < this.updateCheckInterval) return;
//       if (updateElapsed < 24*60*60*1000) return; /* one day */
       iTrustPageMain.autoUpdateQuery= true;
       
     }
	   
     var querystring = "http://www.cs.toronto.edu/~ronda/itrustpage/version3.xml?updateCheck"+
                       "&versionMajorNumber="+this.versionMajorNumber+
                       "&versionMinorNumber="+this.versionMinorNumber+
                       "&versionPatchNumber="+this.versionPatchNumber
                       ;
     this.iTrustPageUpdateQuery = new XMLHttpRequest();   
 	 this.iTrustPageUpdateQuery.onload = function (ev) {
 	      iTrustPageMain.doneUpdateQuery();
 	   }
     this.iTrustPageUpdateQuery.open( "GET", querystring,true );
     this.iTrustPageUpdateQuery.send( null );	   
     
     var updateTime = Date.now();	    	   
     this.prefs.setCharPref("updateLastCheck",updateTime.valueOf());
     this.lastUpdateTime.setTime( this.prefs.getCharPref("updateLastCheck") );	   
     
   },	   
   doneUpdateQuery: function() {
     var updateElapsed = Date.now() - this.lastUpdateTime;	  
	   
	   var response = this.iTrustPageUpdateQuery.responseText;   
	   	   
       var xmldoc = this.iTrustPageUpdateQuery.responseXML;
//       var root_node = xmldoc.getElementsByTagName('root').item(0);
//       alert(root_node.firstChild.data);
       var versionMajorNumber = xmldoc.getElementsByTagName('versionMajorNumber').item(0).textContent;
       var versionMinorNumber = xmldoc.getElementsByTagName('versionMinorNumber').item(0).textContent;
       var versionPatchNumber = xmldoc.getElementsByTagName('versionPatchNumber').item(0).textContent;
       
       if ( (versionMajorNumber > this.versionMajorNumber) ||
            ((versionMajorNumber == this.versionMajorNumber) && (versionMinorNumber > this.versionMinorNumber)) ||
            ((versionMajorNumber == this.versionMajorNumber) && (versionMinorNumber == this.versionMinorNumber) && (versionPatchNumber > this.versionPatchNumber))){

            var versionURL = xmldoc.getElementsByTagName('versionURL').item(0).textContent;
            var versionDownload = xmldoc.getElementsByTagName('versionDownload').item(0).textContent;
            var versionUpdateText = xmldoc.getElementsByTagName('versionUpdateText').item(0).textContent;
	                               
            var updateOK = confirm (versionUpdateText);
            if (updateOK){
	          getBrowser().loadURI(versionURL);	              
	          getBrowser().addTab(versionDownload);
            }           
       }else if (!iTrustPageMain.autoUpdateQuery){
	       alert ("No update is available");   
       }	   
   },   
   observe: function(subject, topic, data)
   {
     if (topic != "nsPref:changed")
     {
       return;
     }
  
     switch(data)
     {
/*	     
       case "checkOnPageLoad":
         this.checkOnPageLoad = this.prefs.getBoolPref("checkOnPageLoad");
         this.invalidateInformation(true);
         this.refreshInformation();
         iTrustPageLog.appendSettingsNode();
         break;
       case "checkOnlyPagesWithInputs":
         this.checkOnlyPagesWithInputs = this.prefs.getBoolPref("checkOnlyPagesWithInputs");
         this.refreshInformation();
         iTrustPageLog.appendSettingsNode();
         break;
       case "checkOnInputFocus":
         this.checkOnInputFocus = this.prefs.getBoolPref("checkOnInputFocus");
         this.refreshInformation();
         iTrustPageLog.appendSettingsNode();
         break;

       case "checkOnKeyboardEvent":
         this.checkOnKeyboardEvent = this.prefs.getBoolPref("checkOnKeyboardEvent");
         this.refreshInformation();
         iTrustPageLog.appendSettingsNode();
         break;
       case "reportUseGooglePageRank":
         this.reportUseGooglePageRank = this.prefs.getBoolPref("reportUseGooglePageRank");                  
         this.invalidateInformation(false);
         this.refreshInformation();
         iTrustPageLog.appendSettingsNode();
         break;
       case "reportUseTrustWatch":
         this.reportUseTrustWatch = this.prefs.getBoolPref("reportUseTrustWatch");
                  
         this.invalidateInformation(false);
         this.refreshInformation();
         iTrustPageLog.appendSettingsNode();
         break;
       case "viewShowStausBar":
         this.viewShowStausBar = this.prefs.getBoolPref("viewShowStausBar");
         this.refreshInformation();
         iTrustPageLog.appendSettingsNode();
         break;
       case "viewStausBarDelay":  
         this.viewStausBarDelay = this.prefs.getIntPref("viewStausBarDelay");
         this.refreshInformation();
         iTrustPageLog.appendSettingsNode();
         break;
       case "debugLevel":
         this.debugLevel = this.prefs.getIntPref("debugLevel");
         this.refreshInformation();
         iTrustPageLog.appendSettingsNode();
         break;
       case "blockAllowBypass":
         this.blockAllowBypass = this.prefs.getBoolPref("blockAllowBypass");
         this.refreshInformation();
         iTrustPageLog.appendSettingsNode();
         break;       
       case "blockAllowSubdomains":
         this.blockAllowSubdomains = this.prefs.getBoolPref("blockAllowSubdomains");
         this.refreshInformation();
         iTrustPageLog.appendSettingsNode();
         break;       
       case "blockPathMustMatch":
         this.blockPathMustMatch = this.prefs.getBoolPref("blockPathMustMatch");
         this.refreshInformation();
         iTrustPageLog.appendSettingsNode();
         break;       
       case "checkAllObjects":
         this.checkAllObjects = this.prefs.getBoolPref("checkAllObjects");
         this.refreshInformation();
         iTrustPageLog.appendSettingsNode();
         break;       
       case "checkNewBookmarks":
         this.checkNewBookmarks = this.prefs.getBoolPref("checkNewBookmarks");
         this.refreshInformation();
         iTrustPageLog.appendSettingsNode();
         break;       
       case "whitelistOnBookmark":
         this.whitelistOnBookmark = this.prefs.getBoolPref("whitelistOnBookmark");
         this.refreshInformation();
         iTrustPageLog.appendSettingsNode();
         break;       
       case "reportUseiTrustPage":
         this.reportUseiTrustPage = this.prefs.getBoolPref("reportUseiTrustPage");
         this.refreshInformation();
         iTrustPageLog.appendSettingsNode();
         break;                
       case "blockKeyThreshold":
         this.blockKeyThreshold = this.prefs.getIntPref("blockKeyThreshold");
         this.refreshInformation();
         iTrustPageLog.appendSettingsNode();
         break;
       case "reportPageRankThreshold":
         this.reportPageRankThreshold = this.prefs.getIntPref("reportPageRankThreshold");
         this.refreshInformation();
         iTrustPageLog.appendSettingsNode();
         break;
       case "cacheTime":
         this.cacheCleanThreshold      =  this.prefs.getIntPref("cacheTime")*60*1000;
         this.refreshInformation();
         iTrustPageLog.appendSettingsNode();
         break;       
       case "cacheFormTime":
     	this.cacheCleanThresholdForms =  Number(this.prefs.getCharPref("cacheFormTime"))*60*1000;
         this.refreshInformation();
         iTrustPageLog.appendSettingsNode();
         break;       
       case "cacheManualTime":
	     this.cacheCleanThresholdManual = Number(this.prefs.getCharPref("cacheManualTime"))*60*1000;
         this.refreshInformation();
         iTrustPageLog.appendSettingsNode();
         break;  
*/              
       case "updateCheckInterval":
	     this.updateCheckInterval = Number(this.prefs.getCharPref("updateCheckInterval"))*60*60*1000;
         this.refreshInformation();
         iTrustPageLog.appendSettingsNode();
         break;
/*                
       case "reportPrefetching":
	     this.reportPrefetching = this.prefs.getBoolPref("reportPrefetching");
         this.refreshInformation();
         iTrustPageLog.appendSettingsNode();
         break;  
*/           
       case "enableLogging":   
	     this.enableLogging = this.prefs.getBoolPref("enableLogging");
        this.refreshInformation();
         iTrustPageLog.appendSettingsNode();
         break; 
/*            
       case "enableBlockExtraInformation":
         this.enableBlockExtraInformation = this.prefs.getBoolPref("enableBlockExtraInformation");     
         this.refreshInformation();
         iTrustPageLog.appendSettingsNode();
         break;      
*/         
     }
     
     
         // ** DISABLE PageRank FUNCTIONS **
         this.reportUseGooglePageRank=false;         
         // ** DISABLE TRUSTWATCH FUNCTIONS **
         this.reportUseTrustWatch=false;
     
  },  
   refreshInformation: function() {
   },
   invalidateInformation: function(force) {
     var rpt = iTrustPage.getCurrentReport();
     
     if (force || !rpt.trackingMode){
        rpt.invalidateURI();
        iTrustPage.checkCurrentUri(false);     
     }
   },
   showOptions: function() {
      window.openDialog( "chrome://itrustpage/content/trustOptions.xul",
                         "itrustpage-options-dialog",
                         "centerscreen,chrome,modal");
                         
   },
   onClearHistory: function() {
   
    var clearOK =confirm("Do you really want to clear your iTrustPage history?");
    if (!clearOK)
       return;  

 	iTrustPageMain.prefs.setCharPref( "whitelist", "" );
    
    iTrustPageWhitelist.load();
  },
  setupAboutBox: function (e){
  },
  getLastURI: function(){
	  //alert (this.DataService.lastURI);
     if (this.DataService.lastURI)
        return this.DataService.lastURI;
     else
        return "";
  },
  getLastDomain: function(){
     if (this.DataService.lastDomain)
        return this.DataService.lastDomain;
     else
        return "";
  },  
  setLastURI: function(uri) {   
    if (uri == "" || uri.substring(0,8) == "internal"){return;}
	  
    //alert (uri);
    
    // if (this.DataService.lastURI != uri)
 	    this.DataService.lastURI = uri;
    //this.prefs.setCharPref( "lastURI", uri );
    
  },
  setLastDomain: function(d) {   
	if (d == "")return;  	

	//if (this.DataService.lastDomain != d)
   	   this.DataService.lastDomain = d;
	//this.prefs.setCharPref( "lastDomain", d );
 	 
    
  },
  notificationEvent: function (ev){
     if (iTrustPageMain.notificationPersist){
//     alert(ev.Target.tagName.toLowerCase());
        //alert("Please complete iTrustPage form");
        //ev.preventDefault();
        //ev.stopPropagation();
        
        window.clearTimeout(this.notifyPersistShowTimeout);

        this.notifyPersistShowTimeout = window.setTimeout(
        function() {
           var b = getBrowser().getBrowserAtIndex(getBrowser().mTabContainer.selectedIndex);
           if (getBrowser().showMessage){
              getBrowser().showMessage(b, iTrustPageMain.lastNotificationImage,
                                       iTrustPageMain.lastNotificationText,
                                       iTrustPageMain.lastNotificationButtonText,"","",
                                       iTrustPageMain.lastNotificationPopup,
                                       iTrustPageMain.lastNotificationPos,true,
                                       iTrustPageMain.lastNotificationButtonAccessKey);
           }     
        }, 100);
        
     }     
  },
  setNotificationPersist: function (persist){
     this.notificationPersist=persist;
     window.clearTimeout(this.notifyHideTimeout);

     if (!persist){
        window.clearTimeout(this.notifyPersistShowTimeout);
        window.clearTimeout(this.notifyShowTimeout);
     }      
  }, 
  notificationShow: function (text/*,image*/) {
     var timeout=this.viewStausBarDelay; /* timeout in seconds */
     var buttonText = "Options...";
     var buttonAccessKey = "o";
     var pos = "top";
     var popup = "trustmenu";
     var image = null;
     
     iTrustPageMain.lastNotificationText = text;
     iTrustPageMain.lastNotificationImage = image;     
     iTrustPageMain.lastNotificationButtonText = buttonText;     
     iTrustPageMain.lastNotificationPopup = popup;     
     iTrustPageMain.lastNotificationPos = pos;     
     iTrustPageMain.lastNotificationButtonAccessKey = buttonAccessKey;     
     
     var b = getBrowser().getBrowserAtIndex(getBrowser().mTabContainer.selectedIndex);

     if (!this.viewShowStausBar)
        return;
     
     window.clearTimeout(this.notifyShowTimeout);
     window.clearTimeout(this.notifyPersistShowTimeout);

        var b = getBrowser().getBrowserAtIndex(getBrowser().mTabContainer.selectedIndex);
        if (getBrowser().showMessage){ /* FOR FIREFOX 1.5 */
           getBrowser().showMessage(b, iTrustPageMain.lastNotificationImage,iTrustPageMain.lastNotificationText,
           iTrustPageMain.lastNotificationButtonText,"","",
           iTrustPageMain.lastNotificationPopup,iTrustPageMain.lastNotificationPos,
           true,iTrustPageMain.lastNotificationButtonAccessKey);
        }else if (getBrowser().getNotificationBox){ /* FOR FIREFOX 2.0 */
           getBrowser().getNotificationBox(b).removeAllNotifications(true);
        
           //var notification = getBrowser().getNotificationBox().getNotificationWithValue("iTrustPage");
           //if (notification){
             // getBrowser().getNotificationBox().removeNotification(notification);	           
             // notification = getBrowser().getNotificationBox().getNotificationWithValue("iTrustPage");
           //}    
        
           //getBrowser().getNotificationBox().notificationsHidden = false;       
           var message = getBrowser().getNotificationBox();
           message.appendNotification(text,"iTrustPage", image,message.PRIORITY_WARNING_HIGH,
             [ {label: buttonText, accessKey: buttonAccessKey, popup: popup } ]); 	        	        
        }           
     
     window.clearTimeout(this.notifyShowTimeout);
     this.notifyShowTimeout = window.setTimeout(
     function() {
        var b = getBrowser().getBrowserAtIndex(getBrowser().mTabContainer.selectedIndex);
        if (getBrowser().showMessage){
           getBrowser().showMessage(b, iTrustPageMain.lastNotificationImage,iTrustPageMain.lastNotificationText,
           iTrustPageMain.lastNotificationButtonText,"","",
           iTrustPageMain.lastNotificationPopup,iTrustPageMain.lastNotificationPos,
           true,iTrustPageMain.lastNotificationButtonAccessKey);
        }else if (getBrowser().getNotificationBox){
/*           getBrowser().getNotificationBox().notificationsHidden = false;       
           var message = getBrowser().getNotificationBox();
           message.appendNotification(text,"iTrustPage", image,message.PRIORITY_WARNING_HIGH,
             [ {label: buttonText, accessKey: buttonAccessKey, popup: popup } ]); 	        	        */
        }           
     }, 200);
     
     if (!this.notificationPersist){
        window.clearTimeout(this.notifyHideTimeout);     
        this.notifyHideTimeout = window.setTimeout(
           function() { iTrustPageMain.notificationHide(); },
           1000 * timeout);
     }
  },
  notificationHide: function () {
     window.clearTimeout(this.notifyHideTimeout);
     window.clearTimeout(this.notifyShowTimeout);
     
     if (getBrowser().getMessageForBrowser){
	   /* FOR FIREFOX 1.5 */
        var message = getBrowser().getMessageForBrowser(getBrowser().selectedBrowser, iTrustPageMain.lastNotificationPos);
        if (message){
           if (message.close) message.close();
           else message.setAttribute("hidden","true");
        }     
    }else if (getBrowser().getNotificationBox){
	   /* FOR FIREFOX 2 */
       //getBrowser().removeCurrentNotification();
      //getBrowser().getNotificationBox().notificationsHidden = true;       
      
      try {
           getBrowser().getNotificationBox(b).removeAllNotifications(true);
//           var notification = getBrowser().getNotificationBox().getNotificationWithValue("iTrustPage");
//           if (notification){
//              getBrowser().getNotificationBox().removeNotification(notification);	           
//              notification = getBrowser().getNotificationBox().getNotificationWithValue("iTrustPage");
//           }        
           
      }catch(err){}
      
    }           
  },
  openWindow: function (url){
      //var b = getBrowser().getBrowserAtIndex(getBrowser().mTabContainer.selectedIndex);
      wOpen = window.open(url,'itrustpage','toolbar=yes, location=yes,directories=yes,status=yes,menubar=yes,scrollbars=yes,copyhistory=yes, resizable=yes');

      wOpen.focus();
      //wOpen.moveTo( 0, 0 );
      wOpen.resizeTo( window.innerWidth, window.innerHeight );	  
      //wOpen.resizeTo( screen.availWidth, screen.availHeight );	  
  },
  showAbout: function() {
      iTrustPageMain.openWindow('http://www.cs.toronto.edu/~ronda/itrustpage/about.html?version='+iTrustPageMain.versionName);
	  /*

      window.openDialog( "chrome://itrustpage/content/about.xul",
                         "itrustpage-about-dialog",
                         "centerscreen,chrome,modal");
                         
      */                   
  },
  viewLog: function() {
	  var filename = iTrustPageLog.getLogFileName();
	  
	  //alert (filename);
	  
	  iTrustPageLog.serialize(false);
	  iTrustPageLog.logClear();
	  
	  getBrowser().loadURI(filename);  
	  
  },
  viewCache: function() {
	  var filename = iTrustPageCache.getCacheFileName();
	  iTrustPageCache.serialize();
	  
	  getBrowser().loadURI(filename);  
	  
  },
  onClearLog: function() {
      var clearOK =confirm("Do you really want to clear your current iTrustPage log?");
      if (!clearOK)
         return;  
         
	  iTrustPageLog.logClear();
//	  iTrustPageLog.serialize(true);
	  
	  alert ("iTrustPage log cleared");
  },
  onClearLogs: function() {
      var clearOK =confirm("Do you really want to clear all of your iTrustPage logs?");
      if (!clearOK)
         return;  
         
	  iTrustPageLog.logClear();
//	  iTrustPageLog.serialize(true);

     // delete all the logs 
     var filename = iTrustPageLog.getLogFileName();
  //   alert (filename);
     
     // file is the given directory (nsIFile)
     /* ensure that the log directory exists */
     var file = Components.classes["@mozilla.org/file/directory_service;1"]
                     .getService(Components.interfaces.nsIProperties)
                     .get("ProfD", Components.interfaces.nsIFile);
     file.append("iTrustPage_logs");
     if( !file.exists() || !file.isDirectory() ) {   // if it doesn't exist, create
        file.create(Components.interfaces.nsIFile.DIRECTORY_TYPE, 0664);
     }          
     
     var entries = file.directoryEntries;
     //var array = [];
     while(entries.hasMoreElements())
     {
        var entry = entries.getNext();
        entry.QueryInterface(Components.interfaces.nsIFile);
       // array.push(entry);
       //alert (entry);
       if (entry && entry.isFile()){
          entry.remove(false);
       }
     }   
	  
	  alert ("iTrustPage logs cleared");
  },
  onClearCurrentCache: function () {
      var clearOK =confirm("Do you really want to clear your iTrustPage cache for the current page?");
      if (!clearOK)
         return;  
	  
	  iTrustPageCache.cacheClearCurrent();
	  alert ("iTrustPage cache cleared for the current page");
  },
  onClearCache: function() {
      var clearOK =confirm("Do you really want to clear your iTrustPage cache?");
      if (!clearOK)
         return;  
	  
	  
	  iTrustPageCache.cacheClear();
	  iTrustPageCache.serialize();	  	  

	  alert ("iTrustPage cache cleared");
  },
  sendLogComplete: function (ev) {
     // done. clear log.
     iTrustPageMain.prefs.setBoolPref("logSLUPdead",false);
     
     /* erase from machine */
     //var SendLogQuery = ev.target;
     //alert (ev.target);
     /*if (!SendLogQuery.file or !SendLogQuery.file.path){
         iTrustPageMain.doSendLogUrlHelper(SendLogQuery.url,SendLogQuery.enableResend);
	     return;
	 }*/
     
	 try {
        //alert ("removing file: "+SendLogQuery.file.path);
        iTrustPageMain.SendLogQuery.file.remove(false);
     }catch (err){
	     /* unknown error... stop sending */
	     
	     //alert ("Error removing log");
	     //alert (iTrustPageMain.SendLogQuery);
	     //alert (iTrustPageMain.SendLogQuery.file);
	     
        iTrustPageMain.logSending = false;
        return;	     
     }
     /* XXX: This is wrong... Now fixed. */
     /* erase from machine */
	 // iTrustPageLog.logClear();
	 // iTrustPageLog.serialize(true);  
	  
     iTrustPageMain.logSending = false;

     if (iTrustPageMain.logSendAlert)
        alert("iTrustPage Log received. Thank You.");     
     // only notify user only once.
     iTrustPageMain.logSendAlert=false;
     	  
     /* send next file */
     window.clearTimeout(iTrustPageMain.nextFileTimeout);
     iTrustPageMain.nextFileTimeout = window.setTimeout(
     function () {
        iTrustPageMain.doSendLogUrlHelper(iTrustPageMain.logUrl,iTrustPageMain.SendLogQuery.enableResend)}, 1000*10);
  },
  sendLog: function () {      
     iTrustPageMain.logSendAlert = true;
     iTrustPageMain.doSendLog();	  
  },
  doSendLogFileToUrl: function (url,file,enableResend){
//	  alert (url+","+file);
	  
      //alert ("sending file: "+file.path);
     /* load the files into an XML document */
     // |file| is nsIFile
     var data = "";
     var fstream = Components.classes["@mozilla.org/network/file-input-stream;1"]
                        .createInstance(Components.interfaces.nsIFileInputStream);
     //alert (fstream);
     var sstream = Components.classes["@mozilla.org/scriptableinputstream;1"]
                        .createInstance(Components.interfaces.nsIScriptableInputStream);
     //alert (sstream);
     
     
     fstream.init(file, 0x01, 00600, 0);
     //alert (fstream);
     sstream.init(fstream); 

     //alert (sstream);
     
     var str = sstream.read(4096);
     while (str.length > 0) {
        data += str;
        str = sstream.read(4096);
     }
     
     var converter = Components.classes["@mozilla.org/intl/scriptableunicodeconverter"]
       .createInstance(Components.interfaces.nsIScriptableUnicodeConverter);

     converter.charset = "UTF-8";
     var streamConvert = converter.convertToInputStream(data);
     sstream.close();
     fstream.close();
 //    alert(data);     
/*
     
     // load an XML object 
     var parser = new DOMParser();
     var xml_doc = parser.parseFromString(data, "text/xml");	  
     var xml_root = xml_doc.documentElement;	       
     */
     var objmulti = Components.classes["@mozilla.org/io/multiplex-input-stream;1"].
     createInstance(Components.interfaces.nsIMultiplexInputStream);

     //objmulti.appendStream(fstream);
     objmulti.appendStream(streamConvert);
      
     //sstream.close();
     //fstream.close();
     
     
     var querystring = url;
     iTrustPageMain.SendLogQuery = new XMLHttpRequest();   
     iTrustPageMain.SendLogQuery.onload = iTrustPageMain.sendLogComplete;
     
     
     iTrustPageMain.SendLogQuery.enableResend = enableResend;
     iTrustPageMain.SendLogQuery.url = url;
     iTrustPageMain.SendLogQuery.enableResend = enableResend;
     iTrustPageMain.SendLogQuery.file = file;
         
     iTrustPageMain.SendLogQuery.open( "POST", querystring,true);
     //alert (xml_doc);
     //alert (objmulti);
     iTrustPageMain.SendLogQuery.send( objmulti );
     
/*     
     if (enableResend){     
        iTrustPageMain.SendLogQuery.onerror = function (evt){
           if (url == "http://flanders3.slup.cs.toronto.edu/cgi-bin/itrustpage/rcvlog.cgi"){
              iTrustPageMain.prefs.setBoolPref("logSLUPdead",true);
//              iTrustPageMain.doSendLogUrl ("http://apu05.utm.utoronto.ca/cgi-bin/itrustpage/rcvlog.cgi",false);  
              iTrustPageMain.doSendLogUrl ("http://flanders3.slup.cs.toronto.edu/cgi-bin/itrustpage/rcvlog.cgi",false);  
           }else{
              iTrustPageMain.prefs.setBoolPref("logSLUPdead",false);
              iTrustPageMain.doSendLogUrl ("http://flanders3.slup.cs.toronto.edu/cgi-bin/itrustpage/rcvlog.cgi",false);  
           }
        }
     }  	
     */  
  },
  doSendLogUrl: function (url,enableResend){
     if (!this.enableLogging){
        alert ("You have disabled logging.");
        return;
     }
     
     /* write the records to disk and clear from memory */
     iTrustPageCache.serialize();	  
     iTrustPageLog.serialize(true);   
     iTrustPageLog.logClear();

     iTrustPageMain.doSendLogUrlHelper(url,enableResend); 

  }, 
  doSendLogUrlHelper: function (url,enableResend){            
     /* send each file in log directory */
     var filename = iTrustPageLog.getLogFileName();
  //   alert (filename);
     
     // file is the given directory (nsIFile)
     /* ensure that the log directory exists */
     var file = Components.classes["@mozilla.org/file/directory_service;1"]
                     .getService(Components.interfaces.nsIProperties)
                     .get("ProfD", Components.interfaces.nsIFile);
     file.append("iTrustPage_logs");
     if( !file.exists() || !file.isDirectory() ) {   // if it doesn't exist, create
        file.create(Components.interfaces.nsIFile.DIRECTORY_TYPE, 0664);
     }          
     
     var entries = file.directoryEntries;
     //var array = [];
     while(entries.hasMoreElements())
     {
        var entry = entries.getNext();
        entry.QueryInterface(Components.interfaces.nsIFile);
       // array.push(entry);
       //alert (entry);
       if (entry && entry.isFile()){
          iTrustPageMain.doSendLogFileToUrl(url,entry,enableResend);       
          return;
       }
     }   

        var updateTime = Date.now();	    	   
        iTrustPageMain.prefs.setCharPref("logSendLast",updateTime.valueOf());
        iTrustPageMain.logSendLast.setTime( iTrustPageMain.prefs.getCharPref("logSendLast") );	   

     /* check if its time to send logs every 10 minutes */
     iTrustPageMain.doLogSendAutoTimer = window.setTimeout(
        iTrustPageMain.doLogSendAuto,
           10*60*1000); /* 10 minutes */        
  },  
  doSendLog: function (){ 
     var slupDead = iTrustPageMain.prefs.getBoolPref("logSLUPdead");
  
 //    alert ("in dosendlog");
     if (!slupDead)
        iTrustPageMain.doSendLogUrl (iTrustPageMain.logUrl,true);  
     else
        iTrustPageMain.doSendLogUrl (iTrustPageMain.logUrl,true);  
        //iTrustPageMain.doSendLogUrl ("http://apu05.utm.utoronto.ca/cgi-bin/itrustpage/rcvlog.cgi",true);  
  },
  doLogChange: function (){  
     if (!iTrustPageMain.enableLogging)
        return;
        
     window.clearTimeout(iTrustPageMain.doLogChangeTimer);
     iTrustPageMain.doLogChangeTimer = window.setTimeout(
        iTrustPageMain.doLogChange,
           20*60*1000); /* 20 minutes */

	  iTrustPageLog.serialize(false);
	  iTrustPageLog.logClear();
             
  },
  doLogSendAuto: function (){  
     if (!iTrustPageMain.enableLogging)
        return;

     window.clearTimeout(iTrustPageMain.doLogChangeTimer);
     /* change the log every 20 minutes */
     iTrustPageMain.doLogChangeTimer = window.setTimeout(
        iTrustPageMain.doLogChange,
           20*60*1000); /* 20 minutes */
           
     window.clearTimeout(iTrustPageMain.doLogSendAutoTimer);
     /* check if its time to send logs every 10 minutes */
     iTrustPageMain.doLogSendAutoTimer = window.setTimeout(
        iTrustPageMain.doLogSendAuto,
           10*60*1000); /* 10 minutes */        
                            
     var sendElapsed = Date.now() - iTrustPageMain.logSendLast;	
    //    alert (sendElapsed +": "+4*60*60*1000);

     // send logs approximately once per two hours */
     if (sendElapsed < 2*60*60*1000) return; /* two hours */
  
     if (iTrustPageMain.logSendAuto){
        iTrustPageMain.logSendAlert = false;
     
        iTrustPageMain.logSending = true;
                
         window.clearTimeout(iTrustPageMain.doLogSendAutoTimer);
         iTrustPageMain.doSendLog();        
     }
  }
  
}
                

window.addEventListener("load", function(e) { iTrustPageMain.startup(); }, false);
window.addEventListener("unload", function(e) { iTrustPageMain.shutdown(); }, false);


///////////////////////////////////////////////////////////////////////////////
// Firefox Listeners:
iTrustPageInitBookmarkListener = function (){

  var bkmkTxn = Components.classes["@mozilla.org/bookmarks/transactionmanager;1"];
                             
  if (bkmkTxn){   /* firefox 2 */                          
     bkmkTxnSvc = bkmkTxn.getService(Components.interfaces.nsIBookmarkTransactionManager);
     bkmkTxnSvc.transactionManager.AddListener(iTrustPageBookmarkListener);
  }else{ /* firefox 1.5 */  
     kRDFContractID   = "@mozilla.org/rdf/rdf-service;1";
     kRDFSVCIID       = Components.interfaces.nsIRDFService;
     RDF              = Components.classes[kRDFContractID].getService(kRDFSVCIID);
     kBMSVCIID = Components.interfaces.nsIBookmarksService;
     BMDS  = RDF.GetDataSource("rdf:bookmarks");
     BMSVC = BMDS.QueryInterface(kBMSVCIID);
  
     BMSVC.transactionManager.AddListener(iTrustPageBookmarkListener);	
	  
  }
  
}

iTrustPageCleanupBookmarkListener = function (){
  var bkmkTxn = Components.classes["@mozilla.org/bookmarks/transactionmanager;1"];

  if (bkmkTxn){ /* firefox 2 */                          
     bkmkTxnSvc = bkmkTxn.getService(Components.interfaces.nsIBookmarkTransactionManager);
     bkmkTxnSvc.transactionManager.RemoveListener(iTrustPageBookmarkListener);
  }else /* firefox 1.5 */
     BMSVC.transactionManager.RemoveListener(iTrustPageBookmarkListener);	
 
 }



var iTrustPageBookmarkListener =
{
  // TODO: THIS ONLY WORKS WHEN THE USER ADDS THE BOOKMARK BY USING THE MENU COMMAND
  //       It does not detect bookmark manager events...
  didDo: function (aTxmgr, aTxn)
  {
//	alert ("?");
    if (aTxn) {
      aTxn = aTxn.wrappedJSObject;

          //alert (aTxn.type);
      	  
	  if (aTxn.type == "insert"){
          if (iTrustPageMain.checkNewBookmarks){
	         var rpt = iTrustPage.getCurrentReportNoTrack();
	         iTrustPage.updateStatusbar();
	          
          }
          
  	      var rpt = iTrustPage.getCurrentReport();     
          rpt.setBookmark();
          iTrustPageLog.appendEventBrowserBookmarkNew(rpt);
          //alert (rpt.currentURI);
          /*if (iTrustPageMain.whitelistOnBookmark){
      	     var rpt = iTrustPage.getCurrentReport();     
      	     
      	     if (rpt.checked && rpt.trusted){
                iTrustPageWhitelist.addUri(rpt.currentURI);      	     
	      	     
      	     }                   
          }*/
		  
      }else{
          var rpt = iTrustPage.getCurrentReportNoTrack();
          iTrustPageLog.appendEventBrowserBookmark(rpt,aTxn.type);	      
      }
    }
  },

  didUndo: function (aTxmgr, aTxn)
  {
  },

  didRedo: function (aTxmgr, aTxn)
  {
  },

  didMerge       : function (aTxmgr, aTxn) {},
  didBeginBatch  : function (aTxmgr, aTxn) {},
  didEndBatch    : function (aTxmgr, aTxn) {},
  willDo         : function (aTxmgr, aTxn) {},
  willUndo       : function (aTxmgr, aTxn) {},
  willRedo       : function (aTxmgr, aTxn) {},
  willMerge      : function (aTxmgr, aTxn) {},
  willBeginBatch : function (aTxmgr, aTxn) {},
  willEndBatch   : function (aTxmgr, aTxn) {}
	    
}
