/* $Id: trustCache.js 5 2006-11-27 06:25:58Z troyronda $ */

/* iTrustPage
 * Copyright (c) 2006 Troy Ronda and the University of Toronto.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */


var iTrustPageCache = 
{
  xml_root: null,
  xml_doc: null,
  DataServiceCache: null,
  nsResolver: null,
	
  cacheStartup: function() {
     var hiddenWindow = Components.classes["@mozilla.org/appshell/appShellService;1"]
         .getService(Components.interfaces.nsIAppShellService)
         .hiddenDOMWindow;
     
     this.DataServiceCache = hiddenWindow.iTrustPageDataServiceCache;
	  
      // get reference to data service document
      this.xml_doc = this.DataServiceCache.getDocument();
      
      // get root to data service document	  
      this.xml_root = this.DataServiceCache.getRoot();
	  
      // get resolver
      this.nsResolver = this.xml_doc.createNSResolver( this.xml_doc.ownerDocument == null ? this.xml_doc.documentElement : this.xml_doc.ownerDocument.documentElement);
            
      this.cacheCleanup();
      
      iTrustPageLog.appendCacheOpenEvent(this.xml_root.childNodes.length);
  },
  cacheShutdown: function () {
	  
  },  
  cacheClear: function (){
     this.DataServiceCache.cacheClear();

      // get reference to data service document
      this.xml_doc = this.DataServiceCache.getDocument();
      
      // get root to data service document	  
      this.xml_root = this.DataServiceCache.getRoot();
	  
      // get resolver
      this.nsResolver = this.xml_doc.createNSResolver( this.xml_doc.ownerDocument == null ? this.xml_doc.documentElement : this.xml_doc.ownerDocument.documentElement);

      iTrustPageLog.appendCacheClearEvent();           	       	  
  },
  cacheClearCurrent: function(){
     this.cacheClearURI(String(rpt.firstDomainURI));
     this.cacheClearURI(String(rpt.currentURI));
  },
  cacheClearURI: function(uri){
     var rpt = iTrustPage.getCurrentReport(); 

     var nodesSnapshot = this.xml_doc.evaluate('/iTrustPageCache/search[@id="'+uri+'"]', this.xml_doc, this.nsResolver, XPathResult.UNORDERED_NODE_SNAPSHOT_TYPE, null );          
     for ( var i=0 ; i < nodesSnapshot.snapshotLength; i++ ){
        this.xml_root.removeChild(nodesSnapshot.snapshotItem(i));
     }              
     var nodesSnapshot = this.xml_doc.evaluate('/iTrustPageCache/report[@id="'+uri+'"]', this.xml_doc, this.nsResolver, XPathResult.UNORDERED_NODE_SNAPSHOT_TYPE, null );          
     for ( var i=0 ; i < nodesSnapshot.snapshotLength; i++ ){
        this.xml_root.removeChild(nodesSnapshot.snapshotItem(i));
     }       
     var nodesSnapshot = this.xml_doc.evaluate('/iTrustPageCache/found[@id="'+uri+'"]', this.xml_doc, this.nsResolver, XPathResult.UNORDERED_NODE_SNAPSHOT_TYPE, null );          
     for ( var i=0 ; i < nodesSnapshot.snapshotLength; i++ ){
        this.xml_root.removeChild(nodesSnapshot.snapshotItem(i));
     }       
     var nodesSnapshot = this.xml_doc.evaluate('/iTrustPageCache/form[@id="'+uri+'"]', this.xml_doc, this.nsResolver, XPathResult.UNORDERED_NODE_SNAPSHOT_TYPE, null );          
     for ( var i=0 ; i < nodesSnapshot.snapshotLength; i++ ){
        this.xml_root.removeChild(nodesSnapshot.snapshotItem(i));
     }       
     var nodesSnapshot = this.xml_doc.evaluate('/iTrustPageCache/trusted[@id="'+uri+'"]', this.xml_doc, this.nsResolver, XPathResult.UNORDERED_NODE_SNAPSHOT_TYPE, null );          
     for ( var i=0 ; i < nodesSnapshot.snapshotLength; i++ ){
        this.xml_root.removeChild(nodesSnapshot.snapshotItem(i));
     }       
     var nodesSnapshot = this.xml_doc.evaluate('/iTrustPageCache/manual[@id="'+uri+'"]', this.xml_doc, this.nsResolver, XPathResult.UNORDERED_NODE_SNAPSHOT_TYPE, null );          
     for ( var i=0 ; i < nodesSnapshot.snapshotLength; i++ ){
        this.xml_root.removeChild(nodesSnapshot.snapshotItem(i));
     }       
     var nodesSnapshot = this.xml_doc.evaluate('/iTrustPageCache/bookmark[@id="'+uri+'"]', this.xml_doc, this.nsResolver, XPathResult.UNORDERED_NODE_SNAPSHOT_TYPE, null );          
     for ( var i=0 ; i < nodesSnapshot.snapshotLength; i++ ){
        this.xml_root.removeChild(nodesSnapshot.snapshotItem(i));
     }       
     
     this.serialize();
  },  
  cacheCleanup: function (){
     // delete reports older than threshold that were not manually entered.     
     var threshold = Date.now() - iTrustPageMain.cacheCleanThreshold;	
     var thresholdForms = Date.now() - iTrustPageMain.cacheCleanThresholdForms;	
     var thresholdManual = Date.now() - iTrustPageMain.cacheCleanThresholdManual;	
          
     var nodesSnapshot = this.xml_doc.evaluate('/iTrustPageCache/report[@created_date<'+threshold+' and @manual = "false" and @bookmark = "false" and @isform="false"]', this.xml_doc, this.nsResolver, XPathResult.UNORDERED_NODE_SNAPSHOT_TYPE, null );          
     for ( var i=0 ; i < nodesSnapshot.snapshotLength; i++ ){
        this.xml_root.removeChild(nodesSnapshot.snapshotItem(i));
     }     
     var nodesSnapshot = this.xml_doc.evaluate('/iTrustPageCache/report[@created_date<'+thresholdForms+' and @manual = "false" and @bookmark = "false" and @isform="true"]', this.xml_doc, this.nsResolver, XPathResult.UNORDERED_NODE_SNAPSHOT_TYPE, null );          
     for ( var i=0 ; i < nodesSnapshot.snapshotLength; i++ ){
        this.xml_root.removeChild(nodesSnapshot.snapshotItem(i));
     }          
     var nodesSnapshot = this.xml_doc.evaluate('/iTrustPageCache/report[@created_date<'+thresholdManual+']', this.xml_doc, this.nsResolver, XPathResult.UNORDERED_NODE_SNAPSHOT_TYPE, null );          
     for ( var i=0 ; i < nodesSnapshot.snapshotLength; i++ ){
        this.xml_root.removeChild(nodesSnapshot.snapshotItem(i));
     }          
     
     var nodesSnapshot = this.xml_doc.evaluate('/iTrustPageCache/trusted[@created_date<'+threshold+']', this.xml_doc, this.nsResolver, XPathResult.UNORDERED_NODE_SNAPSHOT_TYPE, null );          
     for ( var i=0 ; i < nodesSnapshot.snapshotLength; i++ ){
        this.xml_root.removeChild(nodesSnapshot.snapshotItem(i));
     }     

     var nodesSnapshot = this.xml_doc.evaluate('/iTrustPageCache/search[@created_date<'+thresholdForms+' and @manual = "false"]', this.xml_doc, this.nsResolver, XPathResult.UNORDERED_NODE_SNAPSHOT_TYPE, null );          
     for ( var i=0 ; i < nodesSnapshot.snapshotLength; i++ ){
        this.xml_root.removeChild(nodesSnapshot.snapshotItem(i));
     }     
     var nodesSnapshot = this.xml_doc.evaluate('/iTrustPageCache/form[@created_date<'+thresholdForms+' and @manual = "false"]', this.xml_doc, this.nsResolver, XPathResult.UNORDERED_NODE_SNAPSHOT_TYPE, null );          
     for ( var i=0 ; i < nodesSnapshot.snapshotLength; i++ ){
        this.xml_root.removeChild(nodesSnapshot.snapshotItem(i));
     }     
     
     
     
     /* XXX: perhaps should never remove these entries? */
     /*
     var nodesSnapshot = this.xml_doc.evaluate('/iTrustPageCache/form[@created_date<'+thresholdManual+']', this.xml_doc, this.nsResolver, XPathResult.UNORDERED_NODE_SNAPSHOT_TYPE, null );          
     for ( var i=0 ; i < nodesSnapshot.snapshotLength; i++ ){
        this.xml_root.removeChild(nodesSnapshot.snapshotItem(i));
     }     

     var nodesSnapshot = this.xml_doc.evaluate('/iTrustPageCache/manual[@created_date<'+thresholdManual+']', this.xml_doc, this.nsResolver, XPathResult.UNORDERED_NODE_SNAPSHOT_TYPE, null );          
     for ( var i=0 ; i < nodesSnapshot.snapshotLength; i++ ){
        this.xml_root.removeChild(nodesSnapshot.snapshotItem(i));
     }     

     var nodesSnapshot = this.xml_doc.evaluate('/iTrustPageCache/bookmark[@created_date<'+thresholdManual+']', this.xml_doc, this.nsResolver, XPathResult.UNORDERED_NODE_SNAPSHOT_TYPE, null );          
     for ( var i=0 ; i < nodesSnapshot.snapshotLength; i++ ){
        this.xml_root.removeChild(nodesSnapshot.snapshotItem(i));
     }     
     */
               
     this.serialize();
  },
  getCacheFileName: function () {
	  return this.DataServiceCache.getCacheFilename();	  
  },
  serialize: function () {
     this.DataServiceCache.serialize();	  
  },
  createVersionNode: function(){
     var node = this.xml_doc.createElement("version");

     node.setAttribute("versionName",iTrustPageMain.versionName);
     node.setAttribute("versionMajorNumber",iTrustPageMain.versionMajorNumber);
     node.setAttribute("versionMinorNumber",iTrustPageMain.versionMinorNumber);    
     node.setAttribute("versionPatchNumber",iTrustPageMain.versionPatchNumber);    
     
     return node;    	  	  
  },
  createURINode: function (uriType,uri){
     var node = this.xml_doc.createElement("uri");
     var uriRegexp = 
        /^(([^:\/?#]+):)?(\/\/([^\/?#]*))?([^?#]*)(\\?([^#]*))?(#(.*))?/;

     var result = uri.match(uriRegexp);
     
//             digest = iTrustPage_sha2.hex_sha256(whitelist_url[1]);
//        digest = digest.toUpperCase();
     
     node.setAttribute("type",uriType);
     node.setAttribute("uri",uri);
     node.setAttribute("authority",result[4]);
     
     //node.setAttribute("uri_hash",iTrustPage_sha2.hex_sha256(uri).toUpperCase());
     //node.setAttribute("authority_hash",iTrustPage_sha2.hex_sha256(result[4]).toUpperCase());
     
     node.setAttribute("path",result[5]);
     
     //node.setAttribute("path_hash",iTrustPage_sha2.hex_sha256(result[5]).toUpperCase());
     // TODO: Split path and authority and add these as pieces
          	  
     return node;
  },
  createReportNode: function(rpt,useDomain){ 	  
	 var node = this.xml_doc.createElement("report");
	 node.appendChild(this.createVersionNode());
	  
//     var currentURI = this.createURINode("current",rpt.currentURI);
//     var domainURI = this.createURINode("domain",rpt.firstDomainURI);

//     node.appendChild(currentURI);        
//     node.appendChild(domainURI);        
     
     var id = useDomain?rpt.firstDomainURI: rpt.currentURI;

     node.setAttribute("id",id);
     //node.setAttribute("id_hash",iTrustPage_sha2.hex_sha256(id).toUpperCase()); 	  
     
     
     node.setAttribute("pagerank",rpt.pageRank);
     node.setAttribute("trustwatch",rpt.trustwatch);
     node.setAttribute("whitelist",rpt.whitelist);
     node.setAttribute("nonhttp",rpt.nonhttp);
     node.setAttribute("trusted",rpt.trusted);
     node.setAttribute("isform",rpt.isform);       
     node.setAttribute("manual",rpt.manual);     
     node.setAttribute("found",rpt.found);  
     node.setAttribute("found_auto",rpt.found_auto);  
     node.setAttribute("bookmark",rpt.bookmark);  

     node.setAttribute("googleFirstPage",rpt.googleFirstPage);
     
     node.setAttribute("http",rpt.http);  
     node.setAttribute("https",rpt.https);  

     node.setAttribute("local_trust",rpt.local_trust);  
     node.setAttribute("service_trust",rpt.service_trust);  

     node.setAttribute("trusted_from_itrustpagewhitelistdomain",rpt.trusted_from_itrustpagewhitelistdomain);
     node.setAttribute("trusted_from_itrustpagewhitelist",rpt.trusted_from_itrustpagewhitelist);
     
     node.setAttribute("currentDomain", rpt.currentDomain);
     node.setAttribute("currentURI",    rpt.currentURI);
     node.setAttribute("firstDomainURI",rpt.firstDomainURI);
     node.setAttribute("firstDomain",   rpt.firstDomain);     
     
     /*
     node.setAttribute("currentDomain_hash", iTrustPage_sha2.hex_sha256(rpt.currentDomain).toUpperCase());
     node.setAttribute("currentURI_hash",    iTrustPage_sha2.hex_sha256(rpt.currentURI).toUpperCase());
     node.setAttribute("firstDomainURI_hash",iTrustPage_sha2.hex_sha256(rpt.firstDomainURI).toUpperCase());
     node.setAttribute("firstDomain_hash",   iTrustPage_sha2.hex_sha256(rpt.firstDomain).toUpperCase());     
     */
     
     var date_now = new Date();     
     node.setAttribute("created_date",date_now.valueOf());     
     node.setAttribute("accessed_date",date_now.valueOf());     
          
     return node;  
	  
  },
  appendFoundURI: function (uri,auto){
     var myregexp = /^(([^:\/?#]+):)?(\/\/([^\/?#]*))?([^?#]*)(\\?([^#]*))?(#(.*))?/;
     var RegDomain = String(uri).match(myregexp);
           
     if (RegDomain[4])
        uri = RegDomain[2]+"://"+RegDomain[4]+RegDomain[5];
     else
        uri = "internal://"+RegDomain[2]+":"+RegDomain[5];
  
     var iterator = this.xml_doc.evaluate('/iTrustPageCache/found[@id="'+uri+'"]', this.xml_doc, this.nsResolver, XPathResult.ANY_TYPE, null );     
     var node = iterator.iterateNext();
     if (!node){
	    this.xml_root.appendChild(this.createFoundNode(uri,auto));	    	     	  
     }
  },  
  createFoundNode: function (id,auto){
	 var node = this.xml_doc.createElement("found");
	  
     node.setAttribute("id",id); 	  
     //node.setAttribute("id_hash",iTrustPage_sha2.hex_sha256(id).toUpperCase()); 	  
     
     node.setAttribute("auto",auto); 	  

     var date_now = new Date();     
     node.setAttribute("created_date",date_now.valueOf());     
     
     return node;	  
  },	  
  countSearchURI: function (uri){
     var nodesSnapshot = this.xml_doc.evaluate('/iTrustPageCache/search[@id="'+uri+'"]', this.xml_doc, this.nsResolver, XPathResult.UNORDERED_NODE_SNAPSHOT_TYPE, null );          
     return nodesSnapshot.snapshotLength;
  },
  appendSearchURI: function (uri){
     var myregexp = /^(([^:\/?#]+):)?(\/\/([^\/?#]*))?([^?#]*)(\\?([^#]*))?(#(.*))?/;
     var RegDomain = String(uri).match(myregexp);
           
     if (RegDomain[4])
        uri = RegDomain[2]+"://"+RegDomain[4]+RegDomain[5];
     else
        uri = "internal://"+RegDomain[2]+":"+RegDomain[5];
  
	 this.xml_root.appendChild(this.createSearchNode(uri));	    	     	  
  },  
  createSearchNode: function (id){
	 var node = this.xml_doc.createElement("search");
	  
     node.setAttribute("id",id); 	  
     //node.setAttribute("id_hash",iTrustPage_sha2.hex_sha256(id).toUpperCase()); 	  

     var date_now = new Date();     
     node.setAttribute("created_date",date_now.valueOf());     
     
     return node;	  
  },	  
  createBookmarkNode: function (rpt,id){
	 var node = this.xml_doc.createElement("bookmark");
	  
     node.setAttribute("id",id); 	  
     //node.setAttribute("id_hash",iTrustPage_sha2.hex_sha256(id).toUpperCase()); 	  

     var date_now = new Date();     
     node.setAttribute("created_date",date_now.valueOf());     
     node.setAttribute("local_trust",rpt.local_trust);  
     node.setAttribute("service_trust",rpt.service_trust);  
     
     return node;	  
  },	  
  createFormNode: function(rpt,useDomain){
	 var node = this.xml_doc.createElement("form");

	 var id = useDomain?rpt.firstDomainURI: rpt.currentURI
	 	 
     node.setAttribute("id",id); 	  
     //node.setAttribute("id_hash",iTrustPage_sha2.hex_sha256(id).toUpperCase()); 	  
     
     
     node.setAttribute("manual",rpt.manual); 	  

     var date_now = new Date();     
     node.setAttribute("created_date",date_now.valueOf());     
     
     
     return node;
  },
  createTrustedNode: function(rpt,useDomain){     
	 var node = this.xml_doc.createElement("trusted");

	 var id = useDomain?rpt.firstDomainURI: rpt.currentURI;
     node.setAttribute("id",id); 	  
     //node.setAttribute("id_hash",iTrustPage_sha2.hex_sha256(id).toUpperCase()); 	  

     var date_now = new Date();     
     node.setAttribute("created_date",date_now.valueOf());     
          
     return node;
  },
  createManualNode: function(rpt,useDomain) {	  
	 var node = this.xml_doc.createElement("manual");
	 
	 var id = useDomain?rpt.firstDomainURI: rpt.currentURI;
	 
     node.setAttribute("id",id);	  	  
     //node.setAttribute("id_hash",iTrustPage_sha2.hex_sha256(id).toUpperCase()); 	  

     var date_now = new Date();     
     node.setAttribute("created_date",date_now.valueOf());     
     
     return node;
  },  
  cacheReport: function (rpt){
      
	  // TODO: create a new cached report of ANY form that was used...	  
	 if (!rpt.trusted /*|| !rpt.checked*/)
	    return; 
	    
	    //alert ("cacheReport");
	    
//	 alert ("cacheReport a");
	 if (!rpt.fromCache && !rpt.nonhttp && !rpt.fromCache){	  
        var iterator = this.xml_doc.evaluate('/iTrustPageCache/report[@currentURI="'+rpt.currentURI+'" or @firstDomainURI="'+rpt.firstDomainURI+'"]', this.xml_doc, this.nsResolver, XPathResult.ANY_TYPE, null );
        var node = iterator.iterateNext();
        if (!node){     
   	       this.xml_root.appendChild(this.createReportNode(rpt,true));	    
   	       
           // cache trusted reports
           if (!rpt.manual)
              this.xml_root.appendChild(this.createTrustedNode(rpt,true));
     
           // cache manual reports
           if (rpt.manual)
              this.xml_root.appendChild(this.createManualNode(rpt,true));
        }
   	       
	 }

//	 alert ("cacheReport b");
     // cache forms
     if (rpt.isform  && !rpt.nonhttp /*&& !rpt.fromCache*/){
     var iterator = this.xml_doc.evaluate('/iTrustPageCache/form[@id="'+rpt.currentURI+'"]', this.xml_doc, this.nsResolver, XPathResult.ANY_TYPE, null );     
     var node = iterator.iterateNext();
     if (rpt.isform && !node){
        this.xml_root.appendChild(this.createFormNode(rpt,false));	 	 	    
        iTrustPageLog.appendEventReportCacheFirstForm(rpt);

        var iterator = this.xml_doc.evaluate('/iTrustPageCache/report[@currentURI="'+rpt.currentURI+'"]', this.xml_doc, this.nsResolver, XPathResult.ANY_TYPE, null );
        var node = iterator.iterateNext();
        if (!node){     
   	       this.xml_root.appendChild(this.createReportNode(rpt,false));	       	       
   	       
           // cache trusted reports
           if (!rpt.whitelist)
              this.xml_root.appendChild(this.createTrustedNode(rpt,false));
     
           // cache manual reports
           if (rpt.whitelist)
              this.xml_root.appendChild(this.createManualNode(rpt,false));
              
           rpt.fromCache=true;
        }
        else
           node.setAttribute("isform",true);
                
     }
     }

//	 alert ("cacheReport c");
          
     if (rpt.bookmark){
     // cache bookmark
     var iterator = this.xml_doc.evaluate('/iTrustPageCache/bookmark[@id="'+rpt.currentURI+'"]', this.xml_doc, this.nsResolver, XPathResult.ANY_TYPE, null );     
     var node = iterator.iterateNext();
     if (rpt.bookmark && !node){
        this.xml_root.appendChild(this.createBookmarkNode(rpt,rpt.currentURI,false));	 	 	    	     

        var iterator = this.xml_doc.evaluate('/iTrustPageCache/report[@currentURI="'+rpt.currentURI+'"]', this.xml_doc, this.nsResolver, XPathResult.ANY_TYPE, null );
        var node = iterator.iterateNext();
        if (!node){     
   	       this.xml_root.appendChild(this.createReportNode(rpt,false));	       	       
   	       
           // cache trusted reports
           if (!rpt.whitelist)
              this.xml_root.appendChild(this.createTrustedNode(rpt,false));
     
           // cache manual reports
           if (rpt.whitelist)
              this.xml_root.appendChild(this.createManualNode(rpt,false));
        }
        else
           node.setAttribute("bookmark",true);
        	     
     }	  
     }
  },
  getCachedReport: function (rpt){  
     var iterator = this.xml_doc.evaluate('/iTrustPageCache/report[@currentURI="'+rpt.uri+'" or @firstDomainURI="'+rpt.firstDomainURI+'"]', this.xml_doc, this.nsResolver, XPathResult.ANY_TYPE, null );
     
     var node = iterator.iterateNext();
     if (node){     	     
	    rpt.fromCache=true;
	    
	     rpt.trusted = true;
	     rpt.checked = true;
	     rpt.checked_full = true;
	     
         rpt.currentDomain = node.getAttribute("currentDomain");
         rpt.currentURI = node.getAttribute("currentURI");
         rpt.firstDomainURI = node.getAttribute("firstDomainURI");
         rpt.firstDomain =  node.getAttribute("firstDomain");	     
	     
         rpt.pageRank = Number(node.getAttribute("pagerank"));
         rpt.trustwatch = Number(node.getAttribute("trustwatch"));
         rpt.whitelist = node.getAttribute("whitelist")=="true";
         rpt.nonhttp = node.getAttribute("nonhttp")=="true";       
         rpt.manual = node.getAttribute("manual")=="true";   
         rpt.found = node.getAttribute("found")=="true";    
         rpt.found_auto = node.getAttribute("found_auto")=="true";    
         rpt.bookmark = node.getAttribute("bookmark")=="true";    
         rpt.local_trust = node.getAttribute("local_trust")=="true";  
         rpt.service_trust = node.getAttribute("service_trust")=="true";  
         rpt.ishttp = node.getAttribute("https")=="true";  
         rpt.ishttps = node.getAttribute("https")=="true";           
         rpt.isform = node.getAttribute("isform")=="true";  

         rpt.googleFirstPage = node.getAttribute("googleFirstPage")=="true";
                  
         rpt.trusted_from_itrustpagewhitelistdomain = node.getAttribute("trusted_from_itrustpagewhitelistdomain")=="true";  
         rpt.trusted_from_itrustpagewhitelist = node.getAttribute("trusted_from_itrustpagewhitelist")=="true";  
         
         rpt.calculateTrustRank();

	     //iTrustPageLog.appendEventNavigation(rpt);
                  
         var date_now = new Date();     
         node.setAttribute("accessed_date",date_now.valueOf());     	    
     }
     //else {
        var iterator = this.xml_doc.evaluate('/iTrustPageCache/found[@id="'+rpt.uri+'"]', this.xml_doc, this.nsResolver, XPathResult.ANY_TYPE, null );
     
        //alert('/iTrustPageCache/found[@id="'+rpt.uri+'"]');
     
        var node = iterator.iterateNext();
        if (node){     	     
	      //  alert ("found");
 	      rpt.trusted = true;
	      rpt.checked = true;
	      
	      if (rpt.trustwatch > -1 && rpt.pagerank > -1)
  	         rpt.checked_full = true;
	      rpt.local_trusted = true;
	      
	      rpt.found = true;
// 	      rpt.fromCache=true;
 	      	     
          rpt.found_auto = node.getAttribute("auto")=="true";    
        }else 
  	       rpt.fromCache=false;

        if (!rpt.trusted){
           var iterator = this.xml_doc.evaluate('/iTrustPageCache/bookmark[@id="'+rpt.uri+'"]', this.xml_doc, this.nsResolver, XPathResult.ANY_TYPE, null );
     
           var node = iterator.iterateNext();
           if (node){     	     
 	          rpt.trusted = true;
	          rpt.checked = true;
  	          if (rpt.trustwatch > -1 && rpt.pagerank > -1)
   	          rpt.checked_full = true;

             rpt.local_trust = node.getAttribute("local_trust")=="true";  
             rpt.service_trust = node.getAttribute("service_trust")=="true";  

	      
	          rpt.bookmark = true;
// 	          rpt.fromCache=true;
 	      	     
           }       
	        
        }  	         	    
	 //}


	 if (rpt.fromCache){
		 iTrustPageLog.appendEventReportCacheHit(rpt);
		 
		 // it is possible that the user both hit ignore and later validated it... log both cases 
	     if (rpt.manual && rpt.isform)
  	    	 iTrustPageLog.appendEventReportCacheManualForm(rpt);
	     /*else*/ if (rpt.found && rpt.isform)
  	    	 iTrustPageLog.appendEventReportCacheFoundForm(rpt);
	     /*else*/ if (rpt.bookmark && rpt.isform)
  	    	 iTrustPageLog.appendEventReportCacheBookmarkForm(rpt);
  	   
      
        /*if (rpt.trusted){
           iTrustPageMain.setLastURI(rpt.firstDomainURI);
           iTrustPageMain.setLastDomain(rpt.firstDomain);     
        } */    	    	 
  	    	 
  	     /* if not covered by last cases then put into log. */
		 if (rpt.isform && !rpt.found && !rpt.bookmark && !rpt.manual)
			 iTrustPageLog.appendEventReportCacheTrustedForm(rpt);
	 }
  }
}  
