/* $Id: trustDataService.js 5 2006-11-27 06:25:58Z troyronda $ */

/* iTrustPage
 * Copyright (c) 2006 Troy Ronda and the University of Toronto.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */


 
 /* This code is a **HACK**
    I don't have time to implement an XPCOM service today... This needs to be moved into
    such a service to avoid name collisions and because Mozilla might remove the hidden window
    at some point.
    see: http://developer.mozilla.org/en/docs/Working_with_windows_in_chrome_code    
*/

var iTrustPageDataServiceCache = {
  xml_doc: null,  
  xml_root: null,  
  filename: "itrustpage_cache",
  logStream: null,
  initialized: false,
  filename_with_path: "",

  startup: function(){
     if (this.initialized)
        return;
        
     var sString = "";   
        
     this.openCache(true);	  
     
     if (this.inputStream)
        sString = this.inputStream.read( this.inputStream.available() );
     else
        sString = null;
     
     if (!sString){   
	    sString = "<?xml version=\"1.0\"?>"+
	                      "<iTrustPageCache>"+
                          "</iTrustPageCache>";
	  
     } 
     var parser = new DOMParser();
     this.xml_doc = parser.parseFromString(sString, "text/xml");	  
     this.xml_root = this.xml_doc.documentElement;	  
     this.closeCache();	    	       
     
     this.initialized = true;   
  },	
  shutdown: function(){        
     if (!this.initialized)
        return;
        
     this.serialize();
	  
     this.initialized = false;   
  },
  serialize: function (){
     if (!this.initialized)
        return;
     this.openCache(false);	  
	  var s = new XMLSerializer();
	  var str = s.serializeToString(this.xml_doc);
	  	  
      this.cacheStream.write(str, str.length);	     
	  
     this.closeCache();	    	         
	  
  },	
  getDocument: function() {
     return this.xml_doc;	  
  },
  getRoot: function() {
     return this.xml_root;
  },	  
  getCacheFilename: function() {
     return this.filename_with_path;
  },
  cacheClear: function (){
     var sString = "<?xml version=\"1.0\"?>"+
	                      "<iTrustPageCache>"+
                          "</iTrustPageCache>";
	  
     var parser = new DOMParser();
     this.xml_doc = parser.parseFromString(sString, "text/xml");	  
     this.xml_root = this.xml_doc.documentElement;	  	  
  },
  openCache: function(reading){	   	   
     var fileHandle;
     var newFile=false;
    
     // get the path to the user's home (profile) directory
     const DIR_SERVICE = new Components.Constructor("@mozilla.org/file/directory_service;1","nsIProperties");
     try { 
	    path=(new DIR_SERVICE()).get("ProfD", Components.interfaces.nsIFile).path; 
     } catch (e) {
	    alert("error finding profile directory");
     }
     
     // determine the file-separator
     if (path.search(/\\/) != -1) {
	    path = path + "\\";
     } else {
	     path = path + "/";
     }
     var savefile = path+this.filename + ".xml";
     this.filename_with_path = savefile;
     
 	 var fileHandle = Components.classes["@mozilla.org/file/local;1"]
	 	 .createInstance(Components.interfaces.nsILocalFile);
	 fileHandle.initWithPath( savefile );
     
     
     
//     fileHandle = Components.classes["@mozilla.org/file/directory_service;1"]
//                   .getService(Components.interfaces.nsIProperties)
//                   .get("Home", Components.interfaces.nsIFile);
					 
//     fileHandle.append( this.filename + ".xml" )
     
     if (!fileHandle.exists())  
	     newFile = true;	     	   
                            
     /*
			#define PR_RDONLY       0x01
			#define PR_WRONLY       0x02
			#define PR_RDWR         0x04
			#define PR_CREATE_FILE  0x08
			#define PR_APPEND       0x10               
			#define PR_TRUNCATE     0x20
			#define PR_SYNC         0x40
			#define PR_EXCL         0x80
     */
     /* http://www.captain.at/programming/xul/ */
     if (reading){
	    if (newFile){
		    this.cacheStream = null;
		    this.inputStream = null;		    
		    return;
	    }  
	     
        this.cacheStream = Components.classes["@mozilla.org/network/file-input-stream;1"]
                         .createInstance(Components.interfaces.nsIFileInputStream  );
        this.cacheStream.init(fileHandle, 0x01, 00600, 0);     
        
    	this.inputStream = Components.classes["@mozilla.org/scriptableinputstream;1"]
		   .createInstance( Components.interfaces.nsIScriptableInputStream );
	    this.inputStream.init( this.cacheStream );
        
     }else{
        this.cacheStream = Components.classes["@mozilla.org/network/file-output-stream;1"]
                         .createInstance(Components.interfaces.nsIFileOutputStream);
        this.cacheStream.init(fileHandle, 0x02 | 0x08 | 0x20, 00600, 0);     
     }
   },	   
  closeCache: function(){
	  
	  if (this.cacheStream){
         this.cacheStream.close();
         this.cacheStream = null;	
      }
	  
  },
  writeString: function(sString){
     this.cacheStream.write(sString, sString.length);	         	  
  }
}






var iTrustPageDataServiceWhitelist = {
  filename: "itrustpage_whitelist_hash.txt",
  listStream: null,
  initialized: false,
  filename_with_path: "",

  startup: function(){
	 this.checkForUpdate();
     this.openList(true);	  
     this.loadList();
     
     this.initialized = true;   
  },	
  shutdown: function(){        
     if (!this.initialized)
        return;
        	  
     this.initialized = false;   
  },
  getCacheFilename: function() {
     return this.filename_with_path;
  },
  loadListAtPos: function (){
	  var sString = "";
	  var count = 0;
	  
     //alert(fileLength);
     /* each record is 40 bytes */
     while (iTrustPageDataServiceWhitelist.fileLength >= 41){
	     
        sString = iTrustPageDataServiceWhitelist.inputStream.read( 40 );
        iTrustPageDataServiceWhitelist.inputStream.read( 1 );
        iTrustPageDataServiceWhitelist.fileLength = iTrustPageDataServiceWhitelist.fileLength - 41;
	             
        iTrustPageDataServiceWhitelist[sString]=1;
        
        count = count + 1;
        iTrustPageDataServiceWhitelist.pos = iTrustPageDataServiceWhitelist.pos + 1;
        
        if (count > 1000){
	       window.setTimeout ( function (){iTrustPageDataServiceWhitelist.loadListAtPos();},10);
	       return;
        }
     } 
     
     if (iTrustPageDataServiceWhitelist.fileLength < 41){
         iTrustPageDataServiceWhitelist.closeList();	    	       	     
     }           
	  
  },
  loadList: function (){
      this.fileLength =  this.inputStream.available();
      this.filePos = 0;
	  this.loadListAtPos();
  },
  lookupHash: function(sString){
	 if (typeof( this[sString] ) != "undefined")
	    return 1;
	    
	 return 0;
	  
	 // alert (sString + ":" + this[sString]);
     //return (this[sString]);  
  },
  checkForUpdate: function (){
     this.doUpdateQuery();
	  	  
  },
   doUpdateQuery: function (){     	   
     var querystring = "http://www.cs.toronto.edu/~ronda/itrustpage/whitelist_version.xml?updateCheck"+
                       "&versionMajorNumber="+this.versionMajorNumber+
                       "&versionMinorNumber="+this.versionMinorNumber+
                       "&versionPatchNumber="+this.versionPatchNumber
                       ;
     iTrustPageDataServiceWhitelist.iTrustPageUpdateQuery = new XMLHttpRequest();   
 	 iTrustPageDataServiceWhitelist.iTrustPageUpdateQuery.onload = function (ev) {
 	      iTrustPageDataServiceWhitelist.doneUpdateQuery();
 	   }
     iTrustPageDataServiceWhitelist.iTrustPageUpdateQuery.open( "GET", querystring,true );
     iTrustPageDataServiceWhitelist.iTrustPageUpdateQuery.send( null );	   
          
   },
   doneUpdateQuery: function() {	   
	   var response = iTrustPageDataServiceWhitelist.iTrustPageUpdateQuery.responseText;   
	   	   
       var xmldoc = iTrustPageDataServiceWhitelist.iTrustPageUpdateQuery.responseXML;
       //alert (iTrustPageDataServiceWhitelist.iTrustPageUpdateQuery.responseXML);
       var versionMajorNumber = xmldoc.getElementsByTagName('versionMajorNumber').item(0).textContent;
       var versionMinorNumber = xmldoc.getElementsByTagName('versionMinorNumber').item(0).textContent;
       var versionPatchNumber = xmldoc.getElementsByTagName('versionPatchNumber').item(0).textContent;
       
       if ( (versionMajorNumber > this.versionMajorNumber) ||
            ((versionMajorNumber == this.versionMajorNumber) && (versionMinorNumber > this.versionMinorNumber)) ||
            ((versionMajorNumber == this.versionMajorNumber) && (versionMinorNumber == this.versionMinorNumber) && (versionPatchNumber > this.versionPatchNumber))){

            var versionURL = xmldoc.getElementsByTagName('versionURL').item(0).textContent;
            var versionDownload = xmldoc.getElementsByTagName('versionDownload').item(0).textContent;
            var versionUpdateText = xmldoc.getElementsByTagName('versionUpdateText').item(0).textContent;
	                               
       }	   
   },        
  openList: function(reading){	   	   
     var fileHandle;
     var newFile=false;
    
     
     const id = "itrustpage@cs.toronto.edu";
     var ext = Components.classes["@mozilla.org/extensions/manager;1"]
                    .getService(Components.interfaces.nsIExtensionManager)
                    .getInstallLocation(id)
                    .getItemLocation(id); 
     // ext is an instance of nsIFile, so ext.path contains the directory as a string
     //alert(ext.path);
     
     // get the path to the user's home (profile) directory
     const DIR_SERVICE = new Components.Constructor("@mozilla.org/file/directory_service;1","nsIProperties");
     try { 
	    path=(new DIR_SERVICE()).get("ProfD", Components.interfaces.nsIFile).path; 
     } catch (e) {
	    alert("error finding profile directory");
     }
     
     // use the content directory instead
     path = ext.path;
     // determine the file-separator
     if (path.search(/\\/) != -1) {
	    path = path + "\\content\\";
     } else {
	     path = path + "/content/";
     }
     var savefile = path+this.filename;
     this.filename_with_path = savefile;
     
//     alert (this.filename_with_path);
     
 	 var fileHandle = Components.classes["@mozilla.org/file/local;1"]
	 	 .createInstance(Components.interfaces.nsILocalFile);
	 fileHandle.initWithPath( savefile );
     
     if (!fileHandle.exists())  
	     newFile = true;	     	   
                            
     /*
			#define PR_RDONLY       0x01
			#define PR_WRONLY       0x02
			#define PR_RDWR         0x04
			#define PR_CREATE_FILE  0x08
			#define PR_APPEND       0x10               
			#define PR_TRUNCATE     0x20
			#define PR_SYNC         0x40
			#define PR_EXCL         0x80
     */
     /* http://www.captain.at/programming/xul/ */
     if (reading){
	    if (newFile){
		    this.cacheStream = null;
		    this.inputStream = null;		    
		    return;
	    }  
	     
        this.cacheStream = Components.classes["@mozilla.org/network/file-input-stream;1"]
                         .createInstance(Components.interfaces.nsIFileInputStream  );
        this.cacheStream.init(fileHandle, 0x01, 00600, 0);     
        
    	this.inputStream = Components.classes["@mozilla.org/scriptableinputstream;1"]
		   .createInstance( Components.interfaces.nsIScriptableInputStream );
	    this.inputStream.init( this.cacheStream );
        
     }else{
        this.cacheStream = Components.classes["@mozilla.org/network/file-output-stream;1"]
                         .createInstance(Components.interfaces.nsIFileOutputStream);
        this.cacheStream.init(fileHandle, 0x02 | 0x08 | 0x20, 00600, 0);     
     }
   },	   
  closeList: function(){
	  
	  if (this.cacheStream){
         this.cacheStream.close();
         this.cacheStream = null;	
      }
	  
  }
}








//   filename: "itrustpage_whitelist_domain_hash.txt",
var iTrustPageDataServiceWhitelistDomain = {
  filename: "itrustpage_whitelist_domain.txt",
  listStream: null,
  initialized: false,
  domainList: null,
  filename_with_path: "",

  startup: function(){
  
     this.domainList = new Array();
	 this.checkForUpdate();
     this.openList(true);	  
     this.loadList();
     //this.closeList();	    	       
     
     this.initialized = true;   
  },	
  shutdown: function(){        
     if (!this.initialized)
        return;
        	  
     this.initialized = false;   
  },
  getCacheFilename: function() {
     return this.filename_with_path;
  },
  loadListAtPosBackup: function (){
	  var sString = "";
	  var count = 0;
	  
     //alert(fileLength);
     /* each record is 40 bytes */
     while (iTrustPageDataServiceWhitelistDomain.fileLength >= 41){
        sString = iTrustPageDataServiceWhitelistDomain.inputStream.read( 40 );
        iTrustPageDataServiceWhitelistDomain.inputStream.read( 1 );
        iTrustPageDataServiceWhitelistDomain.fileLength = iTrustPageDataServiceWhitelistDomain.fileLength - 41;
	             
        iTrustPageDataServiceWhitelistDomain[sString]=1;
        iTrustPageDataServiceWhitelistDomain.domainList.push(sString);
        
        count = count + 1;
        iTrustPageDataServiceWhitelistDomain.pos = iTrustPageDataServiceWhitelistDomain.pos + 1;
        
        if (count > 1000){
	       window.setTimeout ( function (){iTrustPageDataServiceWhitelistDomain.loadListAtPos();},25);
	       return;
        }
        if (iTrustPageDataServiceWhitelistDomain.fileLength < 41){
           iTrustPageDataServiceWhitelistDomain.closeList();	    	       	     
        }           
        
     }            
	  
  },
  loadListAtPos: function (){
	  var line = {};

//alert ("loading");	  
//alert (iTrustPageDataServiceWhitelistDomain.cacheStream);
	 while (iTrustPageDataServiceWhitelistDomain.cacheStream.readLine(line)){
	    var sString = line.value;
//	 alert (sString);
    	 iTrustPageDataServiceWhitelistDomain.domainList.push(sString);
	 } 
//alert ("done loading");	  
	  
  },
  loadList: function (){
      //this.fileLength =  this.inputStream.available();
      this.filePos = 0;
	  this.loadListAtPos();
  },
  lookupPlain: function(sString){
	// if (typeof( this.domainList[sString] ) != "undefined")
	//    return 1;

     //var bDomainMatches = iTrustPageCommon.utilsIsSameDomain(this.firstDomain,RegDomain[4]);
	 
	 //alert (sString);
	 //alert ("?");
	 for (var i=0; i < this.domainList.length; i++){
//	    alert ("trying: "+this.domainList[i]);
         var bDomainMatches = iTrustPageCommon.utilsIsSameDomain(this.domainList[i],sString);
         
         if (bDomainMatches){
//            alert ("match: "+this.domainList[i]);
            return 1;
         }
	 } 
//	  alert ("no match");
	    
	 return 0;
	  
	 // alert (sString + ":" + this[sString]);
     //return (this[sString]);  
  },
  lookupHash: function(sString){
	 if (typeof( this[sString] ) != "undefined")
	    return 1;
	    
	 return 0;
	  
	 // alert (sString + ":" + this[sString]);
     //return (this[sString]);  
  },
  checkForUpdate: function (){
     this.doUpdateQuery();
	  	  
  },
   doUpdateQuery: function (){     	   
     var querystring = "http://www.cs.toronto.edu/~ronda/itrustpage/whitelist_version.xml?updateCheck"+
                       "&versionMajorNumber="+this.versionMajorNumber+
                       "&versionMinorNumber="+this.versionMinorNumber+
                       "&versionPatchNumber="+this.versionPatchNumber
                       ;
     iTrustPageDataServiceWhitelistDomain.iTrustPageUpdateQuery = new XMLHttpRequest();   
 	 iTrustPageDataServiceWhitelistDomain.iTrustPageUpdateQuery.onload = function (ev) {
 	      iTrustPageDataServiceWhitelistDomain.doneUpdateQuery();
 	   }
     iTrustPageDataServiceWhitelistDomain.iTrustPageUpdateQuery.open( "GET", querystring,true );
     iTrustPageDataServiceWhitelistDomain.iTrustPageUpdateQuery.send( null );	   
          
   },
   doneUpdateQuery: function() {	   
	   var response = iTrustPageDataServiceWhitelistDomain.iTrustPageUpdateQuery.responseText;   
	   	   
       var xmldoc = iTrustPageDataServiceWhitelistDomain.iTrustPageUpdateQuery.responseXML;
       //alert (iTrustPageDataServiceWhitelistDomain.iTrustPageUpdateQuery.responseXML);
       var versionMajorNumber = xmldoc.getElementsByTagName('versionMajorNumber').item(0).textContent;
       var versionMinorNumber = xmldoc.getElementsByTagName('versionMinorNumber').item(0).textContent;
       var versionPatchNumber = xmldoc.getElementsByTagName('versionPatchNumber').item(0).textContent;
       
       if ( (versionMajorNumber > this.versionMajorNumber) ||
            ((versionMajorNumber == this.versionMajorNumber) && (versionMinorNumber > this.versionMinorNumber)) ||
            ((versionMajorNumber == this.versionMajorNumber) && (versionMinorNumber == this.versionMinorNumber) && (versionPatchNumber > this.versionPatchNumber))){

            var versionURL = xmldoc.getElementsByTagName('versionURL').item(0).textContent;
            var versionDownload = xmldoc.getElementsByTagName('versionDownload').item(0).textContent;
            var versionUpdateText = xmldoc.getElementsByTagName('versionUpdateText').item(0).textContent;
	                               
       }	   
   },        
  openList: function(reading){	   	   
     var fileHandle;
     var newFile=false;
    
     const id = "itrustpage@cs.toronto.edu";
     var ext = Components.classes["@mozilla.org/extensions/manager;1"]
                    .getService(Components.interfaces.nsIExtensionManager)
                    .getInstallLocation(id)
                    .getItemLocation(id); 
     // ext is an instance of nsIFile, so ext.path contains the directory as a string
     //alert(ext.path);
     
     // get the path to the user's home (profile) directory
     const DIR_SERVICE = new Components.Constructor("@mozilla.org/file/directory_service;1","nsIProperties");
     try { 
	    path=(new DIR_SERVICE()).get("ProfD", Components.interfaces.nsIFile).path; 
     } catch (e) {
	    alert("error finding profile directory");
     }
     
     // use the content directory instead
     path = ext.path;
     // determine the file-separator
     if (path.search(/\\/) != -1) {
	    path = path + "\\content\\";
     } else {
	     path = path + "/content/";
     }
     var savefile = path+this.filename;
     this.filename_with_path = savefile;
     
 	 var fileHandle = Components.classes["@mozilla.org/file/local;1"]
	 	 .createInstance(Components.interfaces.nsILocalFile);
	 fileHandle.initWithPath( savefile );
     
     if (!fileHandle.exists())  
	     newFile = true;	     	   
                            
     /*
			#define PR_RDONLY       0x01
			#define PR_WRONLY       0x02
			#define PR_RDWR         0x04
			#define PR_CREATE_FILE  0x08
			#define PR_APPEND       0x10               
			#define PR_TRUNCATE     0x20
			#define PR_SYNC         0x40
			#define PR_EXCL         0x80
     */
     /* http://www.captain.at/programming/xul/ */
     if (reading){
	    if (newFile){
		    this.cacheStream = null;
		    this.inputStream = null;		    
		    return;
	    }  
	     
        this.cacheStream = Components.classes["@mozilla.org/network/file-input-stream;1"]
                         .createInstance(Components.interfaces.nsIFileInputStream  );
        this.cacheStream.init(fileHandle, 0x01, 00600, 0);     
      
      /*  
    	this.inputStream = Components.classes["@mozilla.org/scriptableinputstream;1"]
		   .createInstance( Components.interfaces.nsIScriptableInputStream );
	    this.inputStream.init( this.cacheStream );
	  */
	  
	    this.cacheStream.QueryInterface(Components.interfaces.nsILineInputStream);

        
     }else{
        this.cacheStream = Components.classes["@mozilla.org/network/file-output-stream;1"]
                         .createInstance(Components.interfaces.nsIFileOutputStream);
        this.cacheStream.init(fileHandle, 0x02 | 0x08 | 0x20, 00600, 0);     
     }
   },	   
  closeList: function(){
	  
	  if (this.cacheStream){
         this.cacheStream.close();
         this.cacheStream = null;	
      }
	  
  }
}















var iTrustPageDataServiceLog = {
  xml_doc: null,  
  xml_root: null,  
  filename: "itrustpage_log",
  logStream: null,
  initialized: false,
  filename_with_path: "",
  
  startup: function(){
     if (this.initialized)
        return;
        
     this.buildPath();   
     var sLogString = null;   
     
     /*   
     this.openLog(true);	  
     
     if (this.inputStream)
        sLogString = this.inputStream.read( this.inputStream.available() );
     else
        sLogString = null;

     */
//     alert (sLogString);
     
     if (!sLogString){   
	    sLogString = "<?xml version=\"1.0\"?>"+
	                      "<iTrustPageLog>"+
                          "</iTrustPageLog>";
	  
     } 
     var parser = new DOMParser();
     this.xml_doc = parser.parseFromString(sLogString, "text/xml");	  
     this.xml_root = this.xml_doc.documentElement;	  
     //this.closeLog();	    	       
     
     this.initialized = true;   
  },	
  shutdown: function(){        
     if (!this.initialized)
        return;
        
     this.serialize();
	  
     this.initialized = false;   
  },
  logClear: function (){
	 var sString = "<?xml version=\"1.0\"?>"+
	                      "<iTrustPageLog>"+
                          "</iTrustPageLog>";
	  
     var parser = new DOMParser();
     this.xml_doc = parser.parseFromString(sString, "text/xml");	  
     this.xml_root = this.xml_doc.documentElement;	  	  
  },  
  serialize: function (){
     if (!this.initialized)
        return;
//	  alert("?");
     this.openLog(false);	  
	  var s = new XMLSerializer();
	  var str = s.serializeToString(this.xml_doc);
	  
//	  alert (str);
	  
	  if (this.logStream)
        this.logStream.write(str, str.length);	     
	  
     this.closeLog();	    	         
	  
  },
  newSession: function() {
     var node = this.xml_doc.createElement("session");
     var date_now = new Date();

     node.setAttribute("date",date_now.valueOf());
     node.setAttribute("date_locale",date_now.toLocaleDateString());
     node.setAttribute("time_locale",date_now.toLocaleTimeString());    
     
     this.xml_root.appendChild(node);
     return node;    	  
  },	
  buildPath: function () {
     /* ensure that the log directory exists */
     var file = Components.classes["@mozilla.org/file/directory_service;1"]
                     .getService(Components.interfaces.nsIProperties)
                     .get("ProfD", Components.interfaces.nsIFile);
     file.append("iTrustPage_logs");
     if( !file.exists() || !file.isDirectory() ) {   // if it doesn't exist, create
        file.create(Components.interfaces.nsIFile.DIRECTORY_TYPE, 0664);
     }     
     
     
     // get the path to the user's home (profile) directory
     const DIR_SERVICE = new Components.Constructor("@mozilla.org/file/directory_service;1","nsIProperties");
     try { 
	    this.path=(new DIR_SERVICE()).get("ProfD", Components.interfaces.nsIFile).path; 
     } catch (e) {
	    alert("error finding profile directory");
     }
     
     // determine the file-separator
     if (this.path.search(/\\/) != -1) {
	    this.path = this.path + "\\iTrustPage_logs\\";
     } else {
	     this.path = this.path + "/iTrustPage_logs/";
     }	  
  },
  getDocument: function() {
     return this.xml_doc;	  
  },
  getLogFilename: function() {
	  return this.path;
//     return this.filename_with_path;
  },
   openLog: function(reading){	   	   
     var fileHandle;
     var newFile=false;
    
     var file = Components.classes["@mozilla.org/file/directory_service;1"]
                     .getService(Components.interfaces.nsIProperties)
                     .get("ProfD", Components.interfaces.nsIFile);
     file.append("iTrustPage_logs");
     if( !file.exists() || !file.isDirectory() ) {   // if it doesn't exist, create
        file.create(Components.interfaces.nsIFile.DIRECTORY_TYPE, 0664);
     }          
     
     var entries = file.directoryEntries;
     //alert ("test");
     //alert (entries.length);
     
     var count = 0;
     while(entries.hasMoreElements())
     {
        var entry = entries.getNext();
        entry.QueryInterface(Components.interfaces.nsIFile);
        if (entry && entry.isFile()){
           ++count;
        }
     }

     var date_now = new Date();     
     var KillDate = new Date();
     KillDate.setFullYear(2008,6,1); /* set a log kill date of july 1, 2008 */
//     KillDate.setFullYear(2007,5,11); /* set a log kill date of june 11, 2007 */
     KillDate.setHours(0,0,0,0);
     
     //alert (KillDate + "   " +date_now);
     //alert (KillDate.valueOf() + "   " +date_now.valueOf());
     if ( date_now.valueOf() > KillDate.valueOf()   ){
        return;
     }
     
     if (count > 300){  /* cap the number of logs if something goes wrong */
        return;
     }
     
     //alert (count);
     
     /* open a new log with time embedded */     
     var savefile = this.path+this.filename +"_"+date_now.valueOf() + ".xml";
     this.filename_with_path = savefile;
     
 	 var fileHandle = Components.classes["@mozilla.org/file/local;1"]
	 	 .createInstance(Components.interfaces.nsILocalFile);
	 fileHandle.initWithPath( savefile );
     
     
     
//     fileHandle = Components.classes["@mozilla.org/file/directory_service;1"]
//                   .getService(Components.interfaces.nsIProperties)
//                   .get("Home", Components.interfaces.nsIFile);
					 
//     fileHandle.append( this.filename + ".xml" )
     
     if (!fileHandle.exists())  
	     newFile = true;	     	   
     else{
        if (fileHandle.fileSize > (1024*1024*15) ){
//        if (fileHandle.fileSize > (0) ){
//          alert (fileHandle.fileSize);
		    this.logStream = null;
		    this.inputStream = null;		    
		    return;
        }
     }
     
                            
     /*
			#define PR_RDONLY       0x01
			#define PR_WRONLY       0x02
			#define PR_RDWR         0x04
			#define PR_CREATE_FILE  0x08
			#define PR_APPEND       0x10               
			#define PR_TRUNCATE     0x20
			#define PR_SYNC         0x40
			#define PR_EXCL         0x80
     */
     /* http://www.captain.at/programming/xul/ */
     if (reading){
	    if (newFile){
		    this.logStream = null;
		    this.inputStream = null;		    
		    return;
	    }  
	     
        this.logStream = Components.classes["@mozilla.org/network/file-input-stream;1"]
                         .createInstance(Components.interfaces.nsIFileInputStream  );
        this.logStream.init(fileHandle, 0x01, 00600, 0);     
        
    	this.inputStream = Components.classes["@mozilla.org/scriptableinputstream;1"]
		   .createInstance( Components.interfaces.nsIScriptableInputStream );
	    this.inputStream.init( this.logStream );
        
     }else{
        this.logStream = Components.classes["@mozilla.org/network/file-output-stream;1"]
                         .createInstance(Components.interfaces.nsIFileOutputStream);
        this.logStream.init(fileHandle, 0x02 | 0x08 | 0x20, 00600, 0);     
     }
   },	   
  closeLog: function(){
	  
	  if (this.logStream){
         this.logStream.close();
         this.logStream = null;	
      }
	  
  },
  writeString: function(sLogString){
     this.logStream.write(sLogString, sLogString.length);	         	  
  }
	
}	
	
var iTrustPageDataService = {
   initialized: false,   
	
   startup: function (){
     if (this.initialized)
        return;
        
     iTrustPageDataServiceWhitelistDomain.startup();
     iTrustPageDataServiceWhitelist.startup();	   
     iTrustPageDataServiceLog.startup();	   
     iTrustPageDataServiceCache.startup();
     this.initialized = true;   
   },
   shutdown: function (){
     if (!this.initialized)
        return;
	   
     iTrustPageDataServiceWhitelistDomain.shutdown();	   
     iTrustPageDataServiceWhitelist.shutdown();	   
     iTrustPageDataServiceLog.shutdown();	   
     iTrustPageDataServiceCache.shutdown();
   }		
}

	

/* initialize data service */
iTrustPageDataService.startup();

/* add onshutdown to window */
//window.addEventListener("load", function(e) {iTrustPageDataService.startup(); }, false);
window.addEventListener("unload", function(e) { iTrustPageDataService.shutdown(); }, true);
