/* $Id: trustLog.js 9 2006-11-29 00:05:15Z troyronda $ */

/* iTrustPage
 * Copyright (c) 2006 Troy Ronda and the University of Toronto.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */



var iTrustPageLog = 
{
  xml_root: null,
  xml_doc: null,
  DataServiceLog: null,
  count_trusted_reports: 0,
  count_untrusted_reports: 0,
  count_report_cache_hit: 0,
  count_pagerank_queries: 0,
  count_trustwatch_queries: 0,
  /*count_pr0_forms: 0,
  count_pr1_forms: 0,
  count_pr2_forms: 0,
  count_pr3_forms: 0,
  count_pr4_forms: 0,
  count_pr5_forms: 0,
  count_pr6_forms: 0,
  count_pr7_forms: 0,
  count_pr8_forms: 0,
  count_pr9_forms: 0,
  count_pr10_forms: 0,
  count_tw_forms: 0, */
  count_total_forms: 0,
  count_nonhttp_pages: 0,
  /*count_pr0_pages: 0,
  count_pr1_pages: 0,
  count_pr2_pages: 0,
  count_pr3_pages: 0,
  count_pr4_pages: 0,
  count_pr5_pages: 0,
  count_pr6_pages: 0,
  count_pr7_pages: 0,
  count_pr8_pages: 0,
  count_pr9_pages: 0,
  count_pr10_pages: 0,
  count_pr_pages: 0,*/
  count_total_pages: 0,
	
  logStartup: function() {
     var hiddenWindow = Components.classes["@mozilla.org/appshell/appShellService;1"]
         .getService(Components.interfaces.nsIAppShellService)
         .hiddenDOMWindow;
     
     this.DataServiceLog   = hiddenWindow.iTrustPageDataServiceLog;
	  
      // get reference to data service document
      this.xml_doc = this.DataServiceLog.getDocument();
      
      // create a new log for this window	  
      if (iTrustPageMain.enableLogging)   {   
         this.newSession();
	  
         // append version number
         this.xml_root.appendChild(this.createVersionNode());
      
         this.appendEvent("open_log");
      }      
      
  },
  newSession: function () {
	  
     this.count_trusted_reports= 0;
     this.count_untrusted_reports= 0;
     this.count_report_cache_hit= 0;
     this.count_pagerank_queries= 0;
     this.count_trustwatch_queries= 0;
     
  /*this.count_pr0_forms= 0;
  this.count_pr1_forms= 0;
  this.count_pr2_forms= 0;
  this.count_pr3_forms= 0;
  this.count_pr4_forms= 0;
  this.count_pr5_forms= 0;
  this.count_pr6_forms= 0;
  this.count_pr7_forms= 0;
  this.count_pr8_forms= 0;
  this.count_pr9_forms= 0;
  this.count_pr10_forms= 0;
  this.count_tw_forms= 0;*/
  this.count_total_forms= 0;
  this.count_nonhttp_pages= 0;
  /*this.count_pr0_pages= 0;
  this.count_pr1_pages= 0;
  this.count_pr2_pages= 0;
  this.count_pr3_pages= 0;
  this.count_pr4_pages= 0;
  this.count_pr5_pages= 0;
  this.count_pr6_pages= 0;
  this.count_pr7_pages= 0;
  this.count_pr8_pages= 0;
  this.count_pr9_pages= 0;
  this.count_pr10_pages= 0;
  this.count_pr_pages= 0;*/
  this.count_total_pages= 0;
     
  this.count_total_pages_forms= 0;
  this.count_total_pages_inputs= 0;
  this.count_total_pages_textareas= 0;
  this.count_total_pages_embed= 0;
  this.count_total_pages_iframe= 0;
  this.count_total_pages_script= 0;
  
     this.xml_root = this.DataServiceLog.newSession();
  },
  logShutdown: function () {
	  
  },  
  getLogFileName: function () {
	  return this.DataServiceLog.getLogFilename();	  
  },
  serialize: function (force) {
     if (iTrustPageMain.enableLogging){     
	     this.xml_root.setAttribute("count_trusted_reports",this.count_trusted_reports); 
	     this.xml_root.setAttribute("count_untrusted_reports",this.count_untrusted_reports); 
	     this.xml_root.setAttribute("count_report_cache_hit",this.count_report_cache_hit); 
	     this.xml_root.setAttribute("count_pagerank_queries",this.count_pagerank_queries); 
	     this.xml_root.setAttribute("count_trustwatch_queries",this.count_trustwatch_queries); 
	     
	     this.xml_root.setAttribute("count_total_pages_forms",this.count_total_pages_forms);
	     this.xml_root.setAttribute("count_total_pages_inputs",this.count_total_pages_inputs);
	     this.xml_root.setAttribute("count_total_pages_textareas",this.count_total_pages_textareas);
	     this.xml_root.setAttribute("count_total_pages_embed",this.count_total_pages_embed);
	     this.xml_root.setAttribute("count_total_pages_iframe",this.count_total_pages_iframe);
	     this.xml_root.setAttribute("count_total_pages_script",this.count_total_pages_script);

/*	     this.xml_root.setAttribute("count_pr0_forms",this.count_pr0_forms); 
	     this.xml_root.setAttribute("count_pr1_forms",this.count_pr1_forms); 
	     this.xml_root.setAttribute("count_pr2_forms",this.count_pr2_forms); 
	     this.xml_root.setAttribute("count_pr3_forms",this.count_pr3_forms); 
	     this.xml_root.setAttribute("count_pr4_forms",this.count_pr4_forms); 
	     this.xml_root.setAttribute("count_pr5_forms",this.count_pr5_forms); 
	     this.xml_root.setAttribute("count_pr6_forms",this.count_pr6_forms); 
	     this.xml_root.setAttribute("count_pr7_forms",this.count_pr7_forms); 
	     this.xml_root.setAttribute("count_pr8_forms",this.count_pr8_forms); 
	     this.xml_root.setAttribute("count_pr9_forms",this.count_pr9_forms); 
	     this.xml_root.setAttribute("count_pr10_forms",this.count_pr10_forms); */
	     
	     //this.xml_root.setAttribute("count_tw_forms",this.count_tw_forms); 
	     
	     this.xml_root.setAttribute("count_total_forms",this.count_total_forms); 
	     this.xml_root.setAttribute("count_nonhttp_pages",this.count_nonhttp_pages); 
	     
	     /*this.xml_root.setAttribute("count_pr0_pages",this.count_pr0_pages); 
	     this.xml_root.setAttribute("count_pr1_pages",this.count_pr1_pages); 
	     this.xml_root.setAttribute("count_pr2_pages",this.count_pr2_pages); 
	     this.xml_root.setAttribute("count_pr3_pages",this.count_pr3_pages); 
	     this.xml_root.setAttribute("count_pr4_pages",this.count_pr4_pages); 
	     this.xml_root.setAttribute("count_pr5_pages",this.count_pr5_pages); 
	     this.xml_root.setAttribute("count_pr6_pages",this.count_pr6_pages); 
	     this.xml_root.setAttribute("count_pr7_pages",this.count_pr7_pages); 
	     this.xml_root.setAttribute("count_pr8_pages",this.count_pr8_pages); 
	     this.xml_root.setAttribute("count_pr9_pages",this.count_pr9_pages); 
	     this.xml_root.setAttribute("count_pr10_pages",this.count_pr10_pages); */
	     
	     //this.xml_root.setAttribute("count_tw_pages",this.count_tw_pages); 
	     
	     this.xml_root.setAttribute("count_total_pages",this.count_total_pages); 
	     
	     
	 } 
	     
     if (iTrustPageMain.enableLogging || force==true)
        this.DataServiceLog.serialize();	  
  },
  createURINode: function (uriType,uri){
     var node = this.xml_doc.createElement("uri");
     node.setAttribute("type",uriType);
     
     if (uri == "") 
        return node;
        
//     return node;
     var uriRegexp = 
        /^(([^:\/?#]+):)?(\/\/([^\/?#]*))?([^?#]*)(\\?([^#]*))?(#(.*))?/;

     var result = uri.match(uriRegexp);
//     return node;
     
     node.setAttribute("uri",iTrustPage_sha1.sha1HashCache(uri));
     node.setAttribute("scheme",result[1]);
     node.setAttribute("authority",iTrustPage_sha1.sha1HashCache (result[4]));
     node.setAttribute("path",iTrustPage_sha1.sha1HashCache (result[5]));
     
//     return node;
//alert (iTrustPage_sha2);     
     //alert (uri);
     //alert (iTrustPage_sha1.sha1Hash(uri));
     
     // TODO: Split path and authority and add these as pieces
     var path_array=result[5].split("/");
     var authority_array=result[4].split(".");
     
     for (var i=0;i<path_array.length;i++){
        node.setAttribute("path"+i,iTrustPage_sha1.sha1HashCache (path_array[i]));	        
     }
     for (var i=0;i<authority_array.length;i++){
        node.setAttribute("authority"+i,iTrustPage_sha1.sha1HashCache (authority_array[i]));	        
     }
          	  
     return node;
  },
  appendSettingsNode: function (){
     var node = this.appendEvent("settings-change");
     if (node){
        node.setAttribute("checkOnPageLoad",iTrustPageMain.checkOnPageLoad);
        node.setAttribute("checkOnlyPagesWithInputs",iTrustPageMain.checkOnlyPagesWithInputs);
        node.setAttribute("checkOnInputFocus",iTrustPageMain.checkOnInputFocus);
        node.setAttribute("checkOnKeyboardEvent",iTrustPageMain.checkOnKeyboardEvent);
        node.setAttribute("reportUseGooglePageRank",iTrustPageMain.reportUseGooglePageRank);
        node.setAttribute("reportUseTrustWatch",iTrustPageMain.reportUseTrustWatch);
        node.setAttribute("viewShowStausBar",iTrustPageMain.viewShowStausBar);
        node.setAttribute("viewStausBarDelay",iTrustPageMain.viewStausBarDelay);
        node.setAttribute("debugLevel",iTrustPageMain.debugLevel);
        node.setAttribute("blockAllowBypass",iTrustPageMain.blockAllowBypass);
        node.setAttribute("blockAllowSubdomains",iTrustPageMain.blockAllowSubdomains);
        node.setAttribute("blockPathMustMatch",iTrustPageMain.blockPathMustMatch);
        node.setAttribute("checkAllObjects",iTrustPageMain.checkAllObjects);
        node.setAttribute("checkNewBookmarks",iTrustPageMain.checkNewBookmarks);
        node.setAttribute("whitelistOnBookmark",iTrustPageMain.whitelistOnBookmark);
        node.setAttribute("reportUseiTrustPage",iTrustPageMain.reportUseiTrustPage);
        node.setAttribute("reportPageRankThreshold",iTrustPageMain.reportPageRankThreshold);
        node.setAttribute("cacheCleanThreshold",iTrustPageMain.cacheCleanThreshold);
        node.setAttribute("cacheCleanThresholdManual",iTrustPageMain.cacheCleanThresholdManual);
        node.setAttribute("cacheCleanThresholdForms",iTrustPageMain.cacheCleanThresholdForms);
        node.setAttribute("updateCheckInterval",iTrustPageMain.updateCheckInterval);
        node.setAttribute("reportPrefetching",iTrustPageMain.reportPrefetching);
        node.setAttribute("blockKeyThreshold",iTrustPageMain.blockKeyThreshold);   
        
        node.setAttribute("enableBlockExtraInformation",iTrustPageMain.enableBlockExtraInformation);   
        node.setAttribute("enableBlockPrefetch",iTrustPageMain.enableBlockPrefetch);   
             
        
     }    
  },
  createReportNode: function (rpt, detail){
     var node = this.xml_doc.createElement("report");
  
     if (detail){
        var currentURI = this.createURINode("current",rpt.currentURI);
        var domainURI = this.createURINode("domain",rpt.firstDomainURI);

        node.appendChild(currentURI);        
        node.appendChild(domainURI);        
     } else {
        node.setAttribute("currentURI",iTrustPage_sha1.sha1HashCache(currentURI));
        node.setAttribute("domainURI",iTrustPage_sha1.sha1HashCache(domainURI));
     }
     
     //node.setAttribute("pagerank",rpt.pageRank);
     //node.setAttribute("trustwatch",rpt.trustwatch);
     //node.setAttribute("whitelist",rpt.whitelist);
     node.setAttribute("nonhttp",rpt.nonhttp);
     node.setAttribute("trusted",rpt.trusted);
     node.setAttribute("isform",rpt.isform);       
     node.setAttribute("manual",rpt.manual);     
     node.setAttribute("found",rpt.found);  
     node.setAttribute("found_auto",rpt.found_auto);  
     node.setAttribute("bookmark",rpt.bookmark);  
     node.setAttribute("http",rpt.ishttp);  
     node.setAttribute("https",rpt.ishttps);  
     
     node.setAttribute("trusted_from_itrustpagewhitelistdomain",rpt.trusted_from_itrustpagewhitelistdomain);
     node.setAttribute("trusted_from_itrustpagewhitelist",rpt.trusted_from_itrustpagewhitelist);
     
     node.setAttribute("googleFirstPage",rpt.googleFirstPage);

     /*
     node.setAttribute("counts_input_password",rpt.counts_input_password);
     node.setAttribute("counts_input_text",rpt.counts_input_text);
     node.setAttribute("counts_input",rpt.counts_input);
     node.setAttribute("counts_form",rpt.counts_form);
     node.setAttribute("counts_embed",rpt.counts_embed);
     node.setAttribute("counts_iframe",rpt.counts_iframe);
     node.setAttribute("counts_script",rpt.counts_script);
	 */

     return node;
	  
  },
  logClear: function (){
     this.DataServiceLog.logClear();

      // get reference to data service document
      this.xml_doc = this.DataServiceLog.getDocument();
      
      if (iTrustPageMain.enableLogging)   {   
         // get root to data service document	  
         this.newSession();
      
         // append version number
         this.xml_root.appendChild(this.createVersionNode());
      
         this.appendEvent("open_log");
      }
  },  
  appendEventReportCacheHit: function (rpt){
//     var node = this.appendEvent("block-report-cache-hit");
//     var rptNode = this.createReportNode(rpt,true);
     
//     node.appendChild(rptNode);	    

       this.count_report_cache_hit++;
  },	  
  appendCacheOpenEvent: function (count){
     var node = this.appendEvent("cache-open");
     if (node){
        node.setAttribute("count",count);
        node.setAttribute("cacheCleanThreshold",iTrustPageMain.cacheCleanThreshold);
        node.setAttribute("cacheCleanThresholdForms",iTrustPageMain.cacheCleanThresholdForms);
        node.setAttribute("cacheCleanThresholdManual",iTrustPageMain.cacheCleanThresholdManual);
     }
  },	    
  appendCacheClearEvent: function (){
     var node = this.appendEvent("cache-clear");
     
     if (node)
        node.appendChild(rptNode);	    
  },	    
  appendEventReportCacheTrustedForm: function (rpt){
     var node = this.appendEvent("block-report-cache-trusted-form");
     if (node){
        var rptNode = this.createReportNode(rpt,true);
     
        node.appendChild(rptNode);	    
     }
  },	    
  appendEventBrowserBack: function (rpt){
     var node = this.appendEvent("browser-back");
     if (node){
        var rptNode = this.createReportNode(rpt,false);
     
        node.appendChild(rptNode);	    
     }
  },	    
  appendEventBrowserForward: function (rpt){
     var node = this.appendEvent("browser-forward");
     if (node){
        var rptNode = this.createReportNode(rpt,false);
     
        node.appendChild(rptNode);	    
     }
  },	    
  appendEventBrowserBookmarkNew: function (rpt){
     var node = this.appendEvent("browser-bookmark-new");
     if (node){
        var rptNode = this.createReportNode(rpt,true);
     
        node.appendChild(rptNode);	    
     }
  },	    
  appendEventBrowserBookmarkOpen: function (rpt){
     var node = this.appendEvent("browser-bookmark-open");
     if (node){
        var rptNode = this.createReportNode(rpt,true);
     
        node.appendChild(rptNode);	    
     }
  },	    
  appendEventBrowserBookmark: function (rpt,aTxn){
     var node = this.appendEvent("browser-bookmark-txn");
     if (node){
        var rptNode = this.createReportNode(rpt,true);
     
        node.appendChild(rptNode);	    
        node.setAttribute("aTxn",aTxn);
     }
  },	    
  appendEventSubmitForm: function (rpt){
     var node = this.appendEvent("block-submit-form");
     if (node){
        var rptNode = this.createReportNode(rpt,true);
     
        node.appendChild(rptNode);	    
     }
  },	    
  appendEventReportCacheManualForm: function (rpt){
     var node = this.appendEvent("block-report-cache-manual-form");
     if (node){
        var rptNode = this.createReportNode(rpt,true);
      
        node.appendChild(rptNode);	    
     }
  },	    
  appendEventReportCacheFoundForm: function (rpt){
     var node = this.appendEvent("block-report-cache-found-form");
     if (node){
        var rptNode = this.createReportNode(rpt,true);
     
        node.appendChild(rptNode);	            
     }
  },	    
  appendEventReportCacheBookmarkForm: function (rpt){
     var node = this.appendEvent("block-report-cache-bookmark-form");
     if (node){
        var rptNode = this.createReportNode(rpt,true);
     
        node.appendChild(rptNode);	    
     }
  },	    
  appendEventReportCacheFirstForm: function (rpt){
     var node = this.appendEvent("block-report-cache-first-form");
     if (node){
        var rptNode = this.createReportNode(rpt,true);
     
        node.appendChild(rptNode);	    
     }
  },	    
  /* getElementsByTagName WILL NOT GRAB IFRAME CHILDREN!!!! BEWARE!!! */
  /* this is slow right now */
  countTagsInDocument: function (node,tagName){
	  var NodeArray = new Array();
	  
	  //alert (node + "," + tagName);
	  /* loop through child list */
      if (node.contentDocument){
	      //alert (node.tagName);
	      NodeArray = NodeArray.concat ( this.countTagsInDocument(node.contentDocument, tagName) );
      }
      
	     for (var i=0;i<node.childNodes.length;i++){
	        NodeArray = NodeArray.concat ( this.countTagsInDocument(  node.childNodes[i], tagName ) ); 		  
         }
      
      
      if (node.tagName && node.tagName.toLowerCase() == tagName.toLowerCase()){
	      NodeArray.push(node);
      }
      
      return NodeArray;
  },  
  appendGoogleResult: function (uri, num){
     var node = this.appendEvent("google-result");
     if (node){
        var resultURI = this.createURINode("result",uri);
	  
        node.setAttribute("num",num);
        node.appendChild(resultURI);	    
     }
	  
  },
  appendGoogleNavigationFirstPage: function (uri){
     var node = this.appendEvent("google-referrer-first-page");
     if (node){
        var resultURI = this.createURINode("result",uri);	  
        node.appendChild(resultURI);	    
        
        var rptNode = this.createReportNode(rpt,true);     
        node.appendChild(rptNode);	    
        
     }
	  
  },  
  appendEventNavigation: function (rpt,uri,referrer){
	  if (rpt.in_recheck)return;
	  if (this.lastURI == rpt.uri) return;
	  this.lastURI = rpt.uri;
	  
	  //alert ("navigation event: "+rpt.uri+", form: "+rpt.isform+", typed :"+rpt.typed+", nonhttp :"+rpt.nonhttp);
	  
     var node = this.appendEvent("navigation-event");
     if (node){
        var rptNode = this.createReportNode(rpt,false);     
        node.appendChild(rptNode);	    
        
        var nodeURI = this.createURINode("uri",uri);	  
        node.appendChild(nodeURI);	    
        var nodeRef = this.createURINode("referrer",referrer);	  
        node.appendChild(nodeRef);	            
     }

     /* count interesting things on the page */
     var b = getBrowser().getBrowserAtIndex(getBrowser().mTabContainer.selectedIndex);
        //var allTags = this.countTagsInDocument(b.contentDocument,"input");
        var allTags = b.contentDocument.getElementsByTagName("input");     
        this.counts_input = allTags.length;
        node.setAttribute("counts_input",this.counts_input);
	  
        /* count inputs with type=password */
        this.counts_input_password=0;
        this.counts_input_text=0;
        for (var i =0; i< allTags.length; i++){
	       if (allTags[i].type.toLowerCase() == "password"){
		      this.counts_input_password++;       
	       }else if (allTags[i].type.toLowerCase() == "text"){
		      this.counts_input_text++;       
	       }    
        }
        node.setAttribute("counts_input_password",this.counts_input_password);
        node.setAttribute("counts_input_text",this.counts_input_text);
        //alert("trustLog: "+this.counts_input+": "+this.counts_input_password+": "+this.counts_input_text);
        
	  // count forms
        //var allTags = this.countTagsInDocument(b.contentDocument,"form");
        var allTags = b.contentDocument.getElementsByTagName("form");     
        this.counts_form = allTags.length;
        node.setAttribute("counts_form",this.counts_form);


	  // count count_total_pages_textareas
        //var allTags = this.countTagsInDocument(b.contentDocument,"textarea");
        var allTags = b.contentDocument.getElementsByTagName("textarea");     
        this.counts_textareas = allTags.length;
        node.setAttribute("counts_textareas",this.counts_textareas);
                         	  
	  // count embeds
        //var allTags = this.countTagsInDocument(b.contentDocument,"embed");	  
        var allTags = b.contentDocument.getElementsByTagName("embed");     
        this.counts_embed = allTags.length;
        node.setAttribute("counts_embed",this.counts_embed);
	  
	  // count iframes
        //var allTags = this.countTagsInDocument(b.contentDocument,"iframe");	  	  
        var allTags = b.contentDocument.getElementsByTagName("iframe");     
        this.counts_iframe = allTags.length;
        node.setAttribute("counts_iframe",this.counts_iframe);
	  
	  // count scripts
        //var allTags = this.countTagsInDocument(b.contentDocument,"script");	  	  
        var allTags = b.contentDocument.getElementsByTagName("script");     
        this.counts_script = allTags.length;
        node.setAttribute("counts_script",this.counts_script);
	     
        //alert("trustLog2: "+this.counts_input+": "+this.counts_input_password+": "+this.counts_input_text);
        //this.CountsChecked=true;	          
     
     if (this.counts_textareas > 0)
        this.count_total_pages_textareas += 1;
     if (this.counts_form > 0)
        this.count_total_pages_forms += 1;
     if (this.counts_input > 0)
        this.count_total_pages_inputs += 1;
     if (this.counts_embed > 0)
        this.count_total_pages_embed += 1;
     if (this.counts_iframe > 0)
        this.count_total_pages_iframe += 1;
     if (this.counts_script > 0)
        this.count_total_pages_script += 1;
     	  	  	  
	  rpt.typed = false;
	  // categorize uri
	  if (rpt.nonhttp){
         this.count_nonhttp_pages+=1;		  		  
      }else if (rpt.isform){
          this.count_total_forms+=1;
/*	      switch (rpt.pageRank){
		      case 0: this.count_pr0_forms+=1;break;
		      case 1: this.count_pr1_forms+=1;break;
		      case 2: this.count_pr2_forms+=1;break;
		      case 3: this.count_pr3_forms+=1;break;
		      case 4: this.count_pr4_forms+=1;break;
		      case 5: this.count_pr5_forms+=1;break;
		      case 6: this.count_pr6_forms+=1;break;
		      case 7: this.count_pr7_forms+=1;break;
		      case 8: this.count_pr8_forms+=1;break;
		      case 9: this.count_pr9_forms+=1;break;
		      case 10: this.count_pr10_forms+=1;break;
	      }
          if (rpt.trustwatch >= 2){
             this.count_tw_forms+=1;
          } */
      }

      if (!rpt.nonhttp){
      
          this.count_total_pages+=1;
/*	      switch (rpt.pageRank){
		      case 0: this.count_pr0_pages+=1;break;
		      case 1: this.count_pr1_pages+=1;break;
		      case 2: this.count_pr2_pages+=1;break;
		      case 3: this.count_pr3_pages+=1;break;
		      case 4: this.count_pr4_pages+=1;break;
		      case 5: this.count_pr5_pages+=1;break;
		      case 6: this.count_pr6_pages+=1;break;
		      case 7: this.count_pr7_pages+=1;break;
		      case 8: this.count_pr8_pages+=1;break;
		      case 9: this.count_pr9_pages+=1;break;
		      case 10: this.count_pr10_pages+=1;break;
	      }
          if (rpt.trustwatch >= 2){
             this.count_tw_pages+=1;
          }*/
      }
  },
  appendEventFormTypedAll: function (rpt){
	 //alert ("type event: "+rpt.uri+", form: "+rpt.isform+", typed :"+rpt.typed);
     var node = this.appendEvent("block-report-typed-all");
     if (node){
        var rptNode = this.createReportNode(rpt,true);
     
        node.appendChild(rptNode);	    
     }
	  
  },
  appendEventFormTypedAllCount: function (rpt,count){
	 //alert ("type event: "+rpt.uri+", form: "+rpt.isform+", typed :"+rpt.typed);
     var node = this.appendEvent("block-report-typed-all-count");
     if (node){
        var rptNode = this.createReportNode(rpt,false);     
        node.appendChild(rptNode);	    
        
        node.setAttribute("key_count",count);        
     }
	  
  },
  appendEventFormTyped: function (rpt){
	 //alert ("type event: "+rpt.uri+", form: "+rpt.isform+", typed :"+rpt.typed);
     var node = this.appendEvent("block-report-typed");
     if (node){
        var rptNode = this.createReportNode(rpt,true);
     
        node.appendChild(rptNode);	    
     }
	  
  },
  appendEventReportTrusted: function (rpt){
	  // TODO: add to counts
//alert("??");	  
	  this.count_trusted_reports++;
	  
//     var node = this.appendEvent("block-report-trusted");
//     var rptNode = this.createReportNode(rpt,true);
     
//     node.appendChild(rptNode);	    
  },	  
  appendEventReportUntrusted: function (rpt){
	  // TODO: add to counts
	  
	  this.count_untrusted_reports++;
	  
//     var node = this.appendEvent("report-untrusted");
//     var rptNode = this.createReportNode(rpt,true);
     
//     node.appendChild(rptNode);	    
  },	  
  appendEventReportQueryGooglePageRank: function (rpt){
//     var node = this.appendEvent("report-query-google-pagerank");
//     var rptNode = this.createReportNode(rpt,true);
     
//     node.appendChild(rptNode);

       this.count_pagerank_queries++;	    
  },
  appendEventReportQueryTrustWatch: function (rpt){
//     var node = this.appendEvent("report-query-trustwatch");
//     var rptNode = this.createReportNode(rpt,true);
     
//     node.appendChild(rptNode);	    
       this.count_trustwatch_queries++;	    
  },
  appendBlockShowEvent: function (rpt){
     var node = this.appendEvent("block-show");
     if (node){
        var rptNode = this.createReportNode(rpt,true);
     
        node.appendChild(rptNode);	  	  
     }
  },
  appendBlockHideEvent: function (rpt){
     var node = this.appendEvent("block-hide");
     if (node){
        var rptNode = this.createReportNode(rpt,true);
     
        node.appendChild(rptNode);	  	  
     }
  },
  appendBlockAutoFoundEvent: function (rpt){
     var node = this.appendEvent("block-auto-found");
     if (node){
        var rptNode = this.createReportNode(rpt,true);
     
        node.appendChild(rptNode);	  
     }
	  
  },	  
  appendBlockGoogleFoundEvent: function (rpt){
     var node = this.appendEvent("block-google-found");
     if (node){
        var rptNode = this.createReportNode(rpt,true);
     
        node.appendChild(rptNode);	  
     }
	  
  },	  
  appendBlockManualFoundEvent: function (rpt,browserid,redirect){
     var node = this.appendEvent("block-manual-found");
     if (node){
        var rptNode = this.createReportNode(rpt,true);
     
        node.setAttribute("browserid",browserid);
        
        var redirectURI = this.createURINode("redirect",redirect);
        node.appendChild(redirectURI);        
                
        node.appendChild(rptNode);	    
     }
  },
  appendBlockSeachEvent: function (rpt, searchtags){
     var node = this.appendEvent("block-search");
     if (node){
        var rptNode = this.createReportNode(rpt,true);
     
        var newstr = searchtags.replace("\"", "", "gi");
        var searchtags_lc = newstr.toLowerCase();
        var tags = searchtags_lc.split(" ");
        
        node.setAttribute("tags_length",tags.length);
        for (var i=0;i<tags.length;++i){
	        //alert (tags[i]);
           node.setAttribute("tag"+i,iTrustPage_sha1.sha1HashCache(tags[i]));	        
        }
        
        node.appendChild(rptNode);	  
     }
  },  
  appendGoogleSeachEvent: function (searchtags){
     var node = this.appendEvent("google-search");
     if (node){     
        var newstr = searchtags.replace("%22", "", "gi");
        var searchtags_lc = newstr.toLowerCase();
        var tags = searchtags_lc.split("+");
        
        node.setAttribute("tags_length",tags.length);
        for (var i=0;i<tags.length;++i){
//	        alert (tags[i]);
           node.setAttribute("tag"+i,iTrustPage_sha1.sha1HashCache(tags[i]));	        
        }        
     }
  },  
  appendInputFocusEvent: function (){
     var node = this.appendEvent("browser-input-focus");
     if (node){
       // var rptNode = this.createReportNode(rpt,true);
     
       // node.appendChild(rptNode);	  
     }
  },  
  appendInputBlurEvent: function (){
     var node = this.appendEvent("browser-input-blur");
     if (node){
        //var rptNode = this.createReportNode(rpt,true);
     
        // node.appendChild(rptNode);	  
     }
  },  
  appendBlockBypassEvent: function (rpt){
     var node = this.appendEvent("block-bypass");
     if (node){
        var rptNode = this.createReportNode(rpt,true);
     
        node.appendChild(rptNode);	  
     }
  },  
  appendBlockIgnoreBtnEvent: function (rpt){
     var node = this.appendEvent("block-ignore-btn");
     if (node){
        var rptNode = this.createReportNode(rpt,true);
     
        node.appendChild(rptNode);	  
     }
  },  
  appendBlockCancelEvent: function (rpt){
     var node = this.appendEvent("block-cancel");
     if (node){
        var rptNode = this.createReportNode(rpt,true);
     
        node.appendChild(rptNode);	  
     }
  },  
  appendBlockTryNextEvent: function (rpt){
     var node = this.appendEvent("block-next");
     if (node){
        var rptNode = this.createReportNode(rpt,true);
     
        node.appendChild(rptNode);	  	  
     }
  },
  appendBlockTryPrevEvent: function (rpt){
     var node = this.appendEvent("block-prev");
     if (node){
        var rptNode = this.createReportNode(rpt,true);
     
        node.appendChild(rptNode);	  	  
     }
  },
  appendEvent: function(EventType){
     if (iTrustPageMain.enableLogging){
        var date_now = new Date();     
     
//        if (!this.xml_root)
  //       this.newSession();

        var node = this.xml_doc.createElement("event");
        this.xml_root.appendChild(node);
     
        node.setAttribute("type",EventType);
        node.setAttribute("date",date_now.valueOf());
        node.setAttribute("date_locale",date_now.toLocaleDateString());
        node.setAttribute("time_locale",date_now.toLocaleTimeString());    

        return node;    	  
     }
  },
  createVersionString: function(){
	 var sLogString= "<version>\n"+
	               "   <versionName>"+iTrustPageMain.versionName+"</versionName>\n"+
	               "   <versionMajorNumber>"+iTrustPageMain.versionMajorNumber+"</versionMajorNumber>\n"+
	               "   <versionMinorNumber>"+iTrustPageMain.versionMinorNumber+"</versionMinorNumber>\n"+
	               "   <versionPatchNumber>"+iTrustPageMain.versionPatchNumber+"</versionPatchNumber>\n"+
	               "</version>\n";

	 return sLogString;	  
	  
  },
  createVersionNode: function(){
     var node = this.xml_doc.createElement("version");

     /* add firefox version */
     node.setAttribute("userAgent",navigator.userAgent);
     
     node.setAttribute("versionName",iTrustPageMain.versionName);
     node.setAttribute("versionMajorNumber",iTrustPageMain.versionMajorNumber);
     node.setAttribute("versionMinorNumber",iTrustPageMain.versionMinorNumber);    
     node.setAttribute("versionPatchNumber",iTrustPageMain.versionPatchNumber);    
     node.setAttribute("installDate",iTrustPageMain.dateInstall);    
     node.setAttribute("installDate2",iTrustPageMain.dateInstall2);    
     node.setAttribute("installDate3",iTrustPageMain.dateInstall3);    
     node.setAttribute("id",iTrustPageMain.userid);    
     
     return node;    	  	  
  }	    	  
	
}

