/* $Id: trustReport.js 11 2006-11-29 17:31:49Z troyronda $ */

/* iTrustPage
 * Copyright (c) 2006 Troy Ronda and the University of Toronto.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */


 
TrustReport = function() {
  this.uri = "";
  this.checked_full = false;
  this.checked = false;
  this.trusted = false;
  this.local_trust = false;
  this.service_trust = false;
  this.async = true;
  this.fromCache = false;

  this.pageRank = -1;
  this.trustwatch = -1;
  this.nonhttp = false;
  this.whitelist = false;
  this.isform = false;
  this.manual = false;
  this.found = false;
  this.found_auto = false;
  this.bookmark = false;
  this.googleFirstPage = false;

  this.trackingURI = "";
  this.trackingMode = false;
//  this.resetDomainMode = false;
//  this.resetDomainURI = "";
  
  this.currentDomain = "";
  this.currentURI = "";
  this.firstDomainURI = iTrustPageMain.getLastURI();
  this.firstDomain= iTrustPageMain.getLastDomain();
  
  // Previous search state
  this.linkList = new Array();
  this.linkIndex = 0;
  this.tagString = "";
  this.linkURI = "about:blank";
  this.searchAttemptCount = 0;
  this.totalSearches = 3;//iTrustPageMain.reportPageRankThreshold;
  this.userKeysPressed = 0;
  this.blockShowing = false;
  
  // async state
  this.TrustWatchQuery = null;
  this.TrustWatchQuerySent = false;
  this.TrustWatchChecked = false;
  this.GooglePageRankQuery = null;
  this.GooglePageRankQuerySent = false;
  this.GooglePageRankChecked = false;
  this.CacheChecked = false;
  
  this.iTrustPageWhiteListChecked = false;
  this.iTrustPageWhiteListDomainChecked = false;
  
  this.trusted_from_itrustpagewhitelist=false;
  this.trusted_from_itrustpagewhitelistdomain=false;
  
  this.CountsChecked = false;

  this.setURI = function (uri,trackingOnly){ 
     var b = getBrowser().getBrowserAtIndex(getBrowser().mTabContainer.selectedIndex);
     var myregexp = /^(([^:\/?#]+):)?(\/\/([^\/?#]*))?([^?#]*)(\\?([^#]*))?(#(.*))?/;
     var RegDomain = String(uri).match(myregexp);
           
     if (RegDomain[4])
        this.uri = RegDomain[2]+"://"+RegDomain[4]+RegDomain[5];
     else
        this.uri = "internal://"+RegDomain[2]+":"+RegDomain[5];
     
//     if (this.resetDomainMode)
//        this.resetDomain(this.uri);
        
     if (this.checked_full && this.currentURI != "" &&
          (this.uri == this.currentURI)   ){ /* already checked this URI */
          
        this.in_recheck = false;         
        return;
     }

     if (RegDomain[1] == "http:")
        this.ishttp = true;
     if (RegDomain[1] == "https:")
        this.ishttps = true;
     
     var original_uri = this.currentURI;
     var is_domain_match = this.doDomainTracking();
     
    
     // determine search count;
     this.searchAttemptCount = iTrustPageCache.countSearchURI(this.currentURI);
     
     // check for cached report
     if (!this.CacheChecked){
        iTrustPageCache.getCachedReport(this);             
        this.CacheChecked=true;
     
        if (this.trusted)        
           this.CacheChecked=true;
        else{
	        
	        /* see if there was a redirection */
           var uri_temp = this.uri;
           this.uri = iTrustPage.redirectURI;
           //alert ("testing redirect: "+this.uri);
           iTrustPageCache.getCachedReport(this);             
           this.uri=uri_temp;
           this.CacheChecked=true;
           //alert ("done testing redirect: "+this.uri+": "+this.trusted);
        }
     }
     
     /*
     if (!this.CountsChecked){
	  // count inputs
        var allTags = b.contentDocument.getElementsByTagName("input");     
        this.counts_input = allTags.length;
	  
        // count inputs with type=password
        this.counts_input_password=0;
        this.counts_input_text=0;
        for (var i =0; i< allTags.length; i++){
	       if (allTags[i].type.toLowerCase() == "password"){
		      this.counts_input_password++;       
	       }else if (allTags[i].type.toLowerCase() == "text"){
		      this.counts_input_text++;       
	       }    
        }
        //alert("trustReport: "+this.counts_input+": "+this.counts_input_password+": "+this.counts_input_text);
        
	  // count forms
        var allTags = b.contentDocument.getElementsByTagName("form");     
        this.counts_form = allTags.length;
	  
	  // count embeds
        var allTags = b.contentDocument.getElementsByTagName("embed");     
        this.counts_embed = allTags.length;
	  
	  // count iframes
        var allTags = b.contentDocument.getElementsByTagName("iframe");     
        this.counts_iframe = allTags.length;
	  
	  // count scripts
        var allTags = b.contentDocument.getElementsByTagName("script");     
        this.counts_script = allTags.length;
	     
        this.CountsChecked=true;	     
     }*/
    
     // report prefetching (async)
     if (iTrustPageMain.reportPrefetching && trackingOnly){
        this.currentURI = this.uri;   
//        this.async = true;

        if (!this.checked_full)       
           this.doTrustCheck();  
        this.checked = true;
        this.trackingMode=false;     
//        this.calculateTrustRank();     
     }else{

//        if (!this.TrustWatchChecked)
  //         this.GooglePageRankQuerySent = false;
    //    if (!this.GooglePageRankChecked)
      //     this.TrustWatchQuerySent = false;    
	     	     
	     
//	     alert("async off");
        this.async = false;     
     }

     // if async mode has not completed then this operation will
     // be *blocking*
     if (!trackingOnly){
        this.currentURI = this.uri;   

//        this.calculateTrustRank();     
        if (!this.checked_full)       
           this.doTrustCheck();  
        this.trackingMode=false;
        this.checked = true;
        
        if (is_domain_match && original_uri != this.currentURI){ /* page changed */
           //iTrustPageLog.appendEventNavigation(this);	     
        }
        
     }else{
        this.trackingURI = this.uri;   
        this.trackingMode=true;
//        this.calculateTrustRank();     
        if (is_domain_match && original_uri != this.trackingURI){ /* page changed */
           //iTrustPageLog.appendEventNavigation(this);	     
        }
     }
  /*   
             if (this.trusted){
           iTrustPageMain.setLastURI(this.firstDomainURI);
           iTrustPageMain.setLastDomain(this.firstDomain);     
        }                          
*/
     
     if (this.checked_full && this.trusted & !iTrustPage.trustReportCache[this.uri]){
 	           //alert ("adding "+ this.uri + ":"+this.currentURI+":"+this.firstDomainURI);            
        iTrustPage.trustReportCache[this.uri] = this.clone(false);              
               
     }

     this.in_recheck = false;         

  }
  
  this.initState = function (){
     // open data service
     var hiddenWindow = Components.classes["@mozilla.org/appshell/appShellService;1"]
         .getService(Components.interfaces.nsIAppShellService)
         .hiddenDOMWindow;
	  
        this.DataServiceWhitelist   = hiddenWindow.iTrustPageDataServiceWhitelist;
        this.DataServiceWhitelistDomain   = hiddenWindow.iTrustPageDataServiceWhitelistDomain;
	  
        // initialize state
        this.linkList = new Array();
        this.linkIndex = 0;
        this.totalSearches = 3;//iTrustPageMain.reportPageRankThreshold;
        this.searchAttemptCount = 0;

        this.pageRank = -1;
        this.trustwatch = -1;
        this.nonhttp = false;
        this.whitelist = false;
        this.manual = false;
        this.found = false;
        this.found_auto = false;
        this.bookmark = false;
        this.googleFirstPage = false;
        
        this.typed = false;
        this.userKeysPressed = 0;
        
        this.tagString = "";        
        this.linkURI = "about:blank";
        this.trusted = false;
        this.checked = false;
        this.checked_full = false;
        
        this.TrustWatchChecked = false;
        this.GooglePageRankChecked = false;
        this.GooglePageRankQuerySent = false;
        this.TrustWatchQuerySent = false;  
        this.iTrustPageWhiteListChecked=false;  
        this.iTrustPageWhiteListDomainChecked=false;  
        
        this.trusted_from_itrustpagewhitelist=false;
        this.trusted_from_itrustpagewhitelistdomain=false;
        
        this.fromCache = false;     
        this.CacheChecked = false;	  
        this.local_trust = false;
        this.service_trust = false;
        this.in_recheck = false;         
        
        this.isform = false;
        
        //alert ("init state");
        this.async = true;

        this.ishttp = false;
        this.ishttps = false;
        this.blockCurrentText = "";
        this.CountsChecked = false;
        
  }
  
  this.recheck = function (){
//     alert(""+this.trustwatch +" "+ this.pageRank);
     this.checked_full = false;  
     this.in_recheck = true;         
     this.doTrustCheck();
     this.calculateTrustRank();
     iTrustPage.updateStatusbar();                   
  }
  
/*  this.invalidateURI = function (){
     this.initState();
	 /* 
     this.currentURI="";
     this.currentDomain="";
     this.TrustWatchChecked = false;
     this.GooglePageRankChecked = false;
     this.checked_full = false;
     this.checked = false;
     this.trackingMode=true;
     
     this.GooglePageRankQuerySent = false;
     this.TrustWatchQuerySent = false;
     */
  //}

  this.setManual = function (){          
//     this.invalidateURI();
    this.manual = true;
	 this.isform = true;

    this.doTrustCheck();
     
     iTrustPage.checkCurrentUri(false);    	  
  }
  this.setBookmark = function (){
	  if (!this.bookmark){
	     this.bookmark = true;

//        alert ("setBookmark\n");

        if (this.checked_full && this.trusted){
//           alert ("setBookmark2\n");

           iTrustPageCache.cacheReport(this); 
        }           	     
      }   	  	  	  
  }
  
/*  this.doResetDomainMode = function(){
     this.resetDomainMode=true;
     this.resetDomainURI=this.uri;
  }*/
  
/*  this.resetDomain = function(uri){
     if (this.resetDomainURI==uri)
        return;

     this.initState();
            
/*     this.firstDomain = "";
     this.firstDomainURI = "";
     this.currentURI = "";
     this.currentDomain = "";

     this.resetDomainMode=false;
     this.resetDomainURI="";
     this.TrustWatchChecked = false;
     this.GooglePageRankChecked = false;
     this.checked = false;
     this.checked_full = false;

     this.GooglePageRankQuerySent = false;
     this.TrustWatchQuerySent = false;         */
//  }*/
  
  this.setIsForm = function(){
	  if (!this.isform){
	     this.isform = true;

        if (this.checked_full)
           iTrustPageCache.cacheReport(this);             
	     
      }   	  
      if (!this.typed){
	     this.typed = true;
	     
	     // TODO: log this  
	     //alert ("append to log");  
	      iTrustPageLog.appendEventFormTyped(this);
	     //alert ("done append to log");  
      }
  }
  
  this.calculateTrustRank = function(){
     this.totalSearches = 3;//iTrustPageMain.reportPageRankThreshold;

     if (!this.trusted && this.fromCache){
            //this.checked_full = true;        	              
  	        if (this.trusted)
              iTrustPageLog.appendEventReportTrusted(this);
           else
              iTrustPageLog.appendEventReportUntrusted(this);	    
     }

     // lookup SHA1 hash in whitelist.
     if (/*!this.trusted  &&*/ !this.iTrustPageWhiteListChecked){
        var myregexp = /https?:\/\/(.*)/i;
        var whitelist_url = String(this.firstDomainURI).toLowerCase().match(myregexp);	     
	     
        digest = iTrustPage_sha1.sha1HashCache(whitelist_url[1]);
        digest = digest.toUpperCase();
        
        var trust_status = this.DataServiceWhitelist.lookupHash (digest);
        

        if (trust_status == 1){
           this.trusted	=true;
           this.service_trust = true;
           this.trusted_from_itrustpagewhitelist=true;
        }        

        this.iTrustPageWhiteListChecked=true;
     }

     if (/*!this.trusted && */ !this.iTrustPageWhiteListDomainChecked){
        var myregexp = /https?:\/\/([^\/]*)/i;
        var whitelist_url = String(this.firstDomainURI).toLowerCase().match(myregexp);	     
	     

    //    digest = iTrustPage_sha1.sha1HashCache(whitelist_url[1]);
     //   digest = digest.toUpperCase();
        
//        var trust_status = this.DataServiceWhitelistDomain.lookupHash (digest);
        var trust_status = this.DataServiceWhitelistDomain.lookupPlain (whitelist_url[1]);        
        
        if (trust_status == 1){
           this.trusted	=true;
           this.service_trust = true;
           this.trusted_from_itrustpagewhitelistdomain=true;
        }        

        this.iTrustPageWhiteListDomainChecked=true;
     }

     if (!this.trusted){
	     if (this.googleFirstPage){
            this.service_trust = true;
	        this.trusted = true;
         }
     }
     /*               
     if (!this.trusted && iTrustPageMain.reportUseGooglePageRank){
	     
	    if (!this.checked_full && !this.GooglePageRankChecked) 
           this.queryGooglePageRank(this.firstDomainURI);
  
        if (this.pageRank >= iTrustPageMain.reportPageRankThreshold){
           this.trusted=true; 
           this.service_trust = true;
        }
        
     }
     if (!this.trusted && iTrustPageMain.reportUseTrustWatch){
	    if (!this.checked_full && !this.TrustWatchChecked) 
           this.queryTrustWatch();
        
        if (this.trustwatch >= 2){
           this.trusted=true;     
           this.service_trust = true;
        } 
     }*/
     


     ///////////////////////////////////////////////////////////////
     // do caching...     
     if ( !this.checked_full /*&&
        (
             ( iTrustPageMain.reportUseGooglePageRank && iTrustPageMain.reportUseTrustWatch && this.GooglePageRankChecked && this.TrustWatchChecked) ||
             ( iTrustPageMain.reportUseGooglePageRank && !iTrustPageMain.reportUseTrustWatch && this.GooglePageRankChecked) || 
             ( iTrustPageMain.reportUseTrustWatch && !iTrustPageMain.reportUseGooglePageRank && this.TrustWatchChecked) ||
             ( !iTrustPageMain.reportUseGooglePageRank && !iTrustPageMain.reportUseTrustWatch) 
        
        
        )*/){
	        
	        
            this.checked_full = true;       
            iTrustPageCache.cacheReport(this);
            
            if (this.checked_full && this.trusted && !iTrustPage.trustReportCache[this.uri]){
               iTrustPage.trustReportCache[this.uri] = this.clone(false);            
            }
  	        if (this.trusted)
              iTrustPageLog.appendEventReportTrusted(this);
           else
              iTrustPageLog.appendEventReportUntrusted(this);	    

      
     }

      iTrustPage.updateStatusbar();
  }

  this.doneQueryGooglePageRank = function(uri){
	  //alert("done google query");
	 this.GooglePageRankChecked = true; 
	  
     var response = this.GooglePageRankQuery.responseText;

  	 var pr = response.match ( /rank_.*?:.*?:(\d+)/i );
     pr = (pr) ? pr[1] : "-1";     
   	 	
  	 this.pageRank = pr;
  	 this.calculateTrustRank();
  }  
    
  this.queryGooglePageRank = function(uri){
     if (this.GooglePageRankQuerySent)
        return;
	  alert("sending google query: "+uri);
	  
     iTrustPageLog.appendEventReportQueryGooglePageRank(this);
     this.GooglePageRankQuerySent = true;

	 // create query string
	 var url = String (uri);
   	 var reqgr = "info:" + url;
  	 var reqgre = "info:" + encodeURI( url ).replace( /_/, "%5F" );
  	 var GoogleCH = giTrustPageGoogleCHCalc.googleCH( giTrustPageGoogleCHCalc.strord( reqgr ) );
  	 GoogleCH = "6" + giTrustPageGoogleCHCalc.googleNewCh( GoogleCH );

  	 var querystring = "http://";
  	 querystring += "toolbarqueries.google.com/search?client=navclient-auto&ch=" + 
  	                GoogleCH + "&ie=UTF-8&oe=UTF-8&features=Rank"  
  	                 + "&q=" + reqgre;
	    	                 
//     alert(querystring);

     this.GooglePageRankQuery = new XMLHttpRequest();
     this.GooglePageRankQuery.rpt = this;
   
     if (this.async){
	     //alert ("query google async");
 	    this.GooglePageRankQuery.onload = function (ev) {
	 	   if (ev.target.rpt){
 	          ev.target.rpt.doneQueryGooglePageRank();
	       }
 	    }
	 }
	 
     this.GooglePageRankQuery.open( "GET", querystring,this.async,"","" );
     this.GooglePageRankQuery.setRequestHeader( "User-Agent", "Mozilla/4.0 (compatible; GoogleToolbar 2.0.114-big; Windows XP 5.1)" );
     this.GooglePageRankQuery.send( null );

     if (!this.async){
        this.doneQueryGooglePageRank();
     }
//	 return GooglePageRankQuery(uri);
  }

  this.doneTrustWatchQuery = function(){
    var response = this.TrustWatchQuery.responseText;

   // setup reg expressions
   var TrustwatchRegexp = /<font color="#009900">([^<]+)<\/font><br><font color="#666666">([^<]+)<\/font>/g;
   var linkRegexp = /<font color="#009900">([^<]+)<\/font><br><font color="#666666">([^<]+)<\/font>/;
   var uriRegexp = 
        /^(([^:\/?#]+):)?(\/\/([^\/?#]*))?([^?#]*)(\\?([^#]*))?(#(.*))?/;

   this.TrustWatchChecked = true;
   this.trustwatch = 1;
   
   var RegLink = response.match(TrustwatchRegexp);    
   if (RegLink){

      for (i=0;i<RegLink.length;i++){  
         var link = (RegLink[i]).match(linkRegexp);    

         var RegDomain = (link[1]).match(uriRegexp);
         if (link[1] == this.firstDomainURI){    
            if (link[2] == "TrustWatch&reg; Not Verified"){
               this.trustwatch = 1;
            }
            else if (link[2] == "TrustWatch&reg; Verified Secure"){
               this.trustwatch = 2;
            }
            else if (link[2] == "TrustWatch&reg; Verified"){
               this.trustwatch = 2;
            }
            else{
               this.trustwatch = 0;
            }
        }
      }       
   }
   this.calculateTrustRank();
   
}

this.queryTrustWatch = function(){
	if (this.TrustWatchQuerySent)
	   return;
	   
    this.TrustWatchQuerySent = true;   
    iTrustPageLog.appendEventReportQueryTrustWatch(this);


	
   // Parse url
   var tags = encodeURI ( this.firstDomainURI );

    alert("sending TrustWatch query: "+tags);

   // Query TrustWatch
   var querystring = "http://www.trustwatch.com/search?q="
                       +tags+"&submit=+Search+";   

//                       alert(querystring);
   this.TrustWatchQuery = new XMLHttpRequest();
   this.TrustWatchQuery.rpt = this;
   
   if (this.async){
//	     alert ("query trustwatch async");
 	   this.TrustWatchQuery.onload = function (ev) {
	 	   
	 	  if (ev.target.rpt)
 	         ev.target.rpt.doneTrustWatchQuery();
 	   }
	}
   this.TrustWatchQuery.open( "GET", querystring,this.async,"","" );
//   this.TrustWatchQuery.setRequestHeader( "User-Agent", "Mozilla/4.0 (compatible; iTrustPage 1.0; Windows XP 5.1)" );
   this.TrustWatchQuery.send( null );

   if (!this.async){
      this.doneTrustWatchQuery();
   }
} 

  this.queryiTrustPage = function(uri){
     return iTrustPageQuery(uri);
  }

    
  this.doDomainTracking = function(){
     var b = getBrowser().getBrowserAtIndex(getBrowser().mTabContainer.selectedIndex);
     var myregexp = /^(([^:\/?#]+):)?(\/\/([^\/?#]*))?([^?#]*)(\\?([^#]*))?(#(.*))?/;
     var RegDomain = this.uri.match(myregexp);
                             
     this.currentDomain = RegDomain[4];
     var bDomainMatches = iTrustPageCommon.utilsIsSameDomain(this.firstDomain,RegDomain[4]);
     
     // check if we have navigated into a new authority
     // TODO: check if we are just navigating into a new subdomain of the same authority
     // let that through   
     
     if ((this.checked_full && !this.trusted && this.firstDomainURI != this.uri) 
        || !bDomainMatches){
	        
	    this.initState();    
	    //alert ("init state in domain tracking"+this.firstDomainURI +","+ this.uri+","+bDomainMatches+","+this.firstDomain+","+RegDomain[4]);    
	    
        this.firstDomain = RegDomain[4];
        this.firstDomainURI = this.uri;
 
        // TODO: serialize into cache
        return false; 
     }

     return true;
  }
  
  this.doTrustCheck = function() {
     var b = getBrowser().getBrowserAtIndex(getBrowser().mTabContainer.selectedIndex);                             
            
     /*
     // look for whitelist
     if (iTrustPageWhitelist.isUriInWhiteList(this.firstDomainURI)){
         this.whitelist = true;
         this.local_trust = true;
	      this.trusted=true;
	      
	      if (!this.checked_full){
            this.checked_full = true;       
            //iTrustPageLog.appendEventNavigation(this);
          }
          
       return;
     }else
        this.whitelist = false;
     */
        
     if (this.manual){
       this.local_trust = true;
	    this.trusted=true;
	    
	    if (this.fromCache)
   	    return;    
     }

     if (this.found){
       this.local_trust = true;
	    this.trusted=true;

	    if (this.fromCache)
   	    return;    
     }
     
     if (this.bookmark){
	     this.trusted = true;
	     
 	     if (this.fromCache)
   	    return;    
     }
     
          
     // look for HTTP transactions     
     if (this.uri.substr (0,4) != "http"){
        this.nonhttp = true;
        this.trusted=true; // we only care about http.*
        
	    if (!this.checked_full){        
           this.checked_full = true;       
           //iTrustPageLog.appendEventNavigation(this);
        }
           
        return;
     }else
        this.nonhttp = false;
     
    
     // look for an input field
     /*
     var inputs = b.contentDocument.getElementsByTagName("input");
     if (iTrustPageMain.checkOnlyPagesWithInputs && inputs.length == 0){
       this.trusted=true; // we only care about pages with input
       
	   if (!this.checked_full){
          this.checked_full = true;       
          //iTrustPageLog.appendEventNavigation(this);
       }
       return;
     }
     
     if (iTrustPageMain.reportUseiTrustPage){
        this.iTrustPage = this.queryiTrustPage(this.firstDomainURI);
     
     }
     
     if (iTrustPageMain.reportUseGooglePageRank){
	     
	    if (!this.GooglePageRankChecked) 
           this.queryGooglePageRank(this.firstDomainURI);         
     }
     if (iTrustPageMain.reportUseTrustWatch){
        if (!this.TrustWatchChecked)
           this.queryTrustWatch();                
     }     
     */
     
     this.calculateTrustRank();
     // TODO: if there is a form, block further interaction on this tab
     // TODO: if trusted then release tab   
     // TODO: cache results  
  };
  
  this.getNotificationMessage = function(){
     var msgText = "";

     
     
     switch (iTrustPageMain.debugLevel){
     case 0:       
       if (this.trusted)
           msgText += "iTrustPage: [Verified Page - Green] ";                  
       else 
           msgText += "iTrustPage: [Unverified Page - Orange] ";                  
     
       msgText += " -- Based on URL: "+this.firstDomainURI+". Reasons: ";
        if (this.pageRank >= 0)
           msgText += " [Popularity "+this.pageRank+" out of 10]";
        if (this.trustwatch >= 0){
           msgText += " [TrustWatch ";      
        
           switch (this.trustwatch){
           case 0:
              msgText += "Blacklist";      
              break;
           case 1:
              msgText += "Unverified";      
              break;
           case 2:
              msgText += "Verified";      
              break;
           }           
           msgText += "]";                 
       }
       if (this.form)
           msgText += " [Form]";                  
       if (this.bookmark)
           msgText += " [Bookmarked]";       
       if (this.found)
           msgText += " [Found by User]";
       if (this.manual)
           msgText += " [Bypassed Tool]";
       if (this.fromCache)
           msgText += " [Cache Hit]";
       if (this.nonhttp)
           msgText += " [Not HTTP]";
       if (this.whitelist)
           msgText += " [Whitelisted]";
       break;
     case 1:
        msgText += "; URI="+this.uri;
        msgText += "; DomainURI="+this.firstDomainURI;
        msgText += "; PageRank="+this.pageRank;
        msgText += "; TrustWatch="+this.trustwatch;      
        break;
     case 2:
        msgText += "; URI="+this.uri;
        msgText += "; currentURI="+this.currentURI;
        msgText += "; trackingURI="+this.trackingURI;
        msgText += "; DomainURI="+this.firstDomainURI;
        msgText += "; Checked="+this.checked;
        msgText += "; PageRank="+this.pageRank;
        msgText += "; TrustWatch="+this.trustwatch;      
        msgText += "; Trusted="+this.trusted;      
        msgText += "; TrackingMode="+this.trackingMode;      
        break;
     }
     
     
     return msgText;
  };
  
  this.clone = function (deep) {
     //alert ("clone");
     var objectClone = new this.constructor();
     for (var property in this){
       if (!deep)
          objectClone[property] = this[property];
       else if (typeof this[property] == 'object')
          objectClone[property] = this[property].clone(deep);
       else
         objectClone[property] = this[property];
     }
         
     return objectClone;
  };

  this.createURINode = function (xml_doc,uriType,uri){
     var node = xml_doc.createElement("uri");
     var uriRegexp = 
        /^(([^:\/?#]+):)?(\/\/([^\/?#]*))?([^?#]*)(\\?([^#]*))?(#(.*))?/;

     var result = uri.match(uriRegexp);
     
     node.setAttribute("type",uriType);
     node.setAttribute("uri",uri);
     node.setAttribute("scheme",result[1]);
     node.setAttribute("authority",result[4]);
     node.setAttribute("path",result[5]);
     
     // TODO: Split path and authority and add these as pieces
     var path_array=result[5].split("/");
     var authority_array=result[4].split(".");
     
     for (var i=0;i<path_array.length;i++){
        node.setAttribute("path"+i,path_array[i]);	        
     }
     for (var i=0;i<authority_array.length;i++){
        node.setAttribute("authority"+i,authority_array[i]);	        
     }
          	  
     return node;
  };
      
  this.CreateXMLReportNode = function (xml_doc){
	  
     var node = xml_doc.createElement("report");
     var rpt = this;
  
     var currentURI = this.createURINode(xml_doc,"current",rpt.currentURI);
     var domainURI = this.createURINode(xml_doc,"domain",rpt.firstDomainURI);

     node.appendChild(currentURI);        
     node.appendChild(domainURI);        
     
     node.setAttribute("ReportType",rpt.ReportType);  
     node.setAttribute("RedirectURL",rpt.RedirectURL);  
     //node.setAttribute("pagerank",rpt.pageRank);
     //node.setAttribute("trustwatch",rpt.trustwatch);
     //node.setAttribute("whitelist",rpt.whitelist);
     node.setAttribute("nonhttp",rpt.nonhttp);
     node.setAttribute("trusted",rpt.trusted);
     node.setAttribute("isform",rpt.isform);       
     node.setAttribute("manual",rpt.manual);     
     node.setAttribute("found",rpt.found);  
     node.setAttribute("found_auto",rpt.found_auto);  
     node.setAttribute("bookmark",rpt.bookmark);  
     node.setAttribute("http",rpt.ishttp);  
     node.setAttribute("https",rpt.ishttps);  

     return node;
	  
  };	  
  
  
  this.SubmitReport = function (ReportType,RedirectURL){
     this.ReportType = ReportType;
     this.RedirectURL = RedirectURL;

     this.DoSubmitReport ();     
  };
  
  this.createVersionNode = function (xml_doc){
     var node = xml_doc.createElement("version");

     node.setAttribute("versionName",iTrustPageMain.versionName);
     node.setAttribute("versionMajorNumber",iTrustPageMain.versionMajorNumber);
     node.setAttribute("versionMinorNumber",iTrustPageMain.versionMinorNumber);    
     node.setAttribute("versionPatchNumber",iTrustPageMain.versionPatchNumber);    
     node.setAttribute("installDate",iTrustPageMain.dateInstall);    
     node.setAttribute("installDate2",iTrustPageMain.dateInstall2);    
     node.setAttribute("installDate3",iTrustPageMain.dateInstall3);    
     node.setAttribute("id",iTrustPageMain.userid);    
     
     return node;    	  	  
  }; 	
  
  this.DoSubmitReport = function (){

	 // create XML document of report
	 var sString = "<?xml version=\"1.0\"?>"+
	                      "<iTrustPageSubmission>"+
                          "</iTrustPageSubmission>";
	  
     var parser = new DOMParser();
     var xml_doc = parser.parseFromString(sString, "text/xml");	  
     var xml_root = xml_doc.documentElement;	  
          
     var node = this.CreateXMLReportNode(xml_doc);
     xml_root.appendChild (node);
     
     var node = this.createVersionNode(xml_doc);
     xml_root.appendChild (node);     
     
     var serializer = new XMLSerializer();
     var xml = serializer.serializeToString(xml_doc);
     
     // send report to our server     
     var querystring = "http://flanders3.slup.cs.toronto.edu/cgi-bin/itrustpage/submissions/rcvsubmission.cgi";
     this.SendReportQuery = new XMLHttpRequest();   
     this.SendReportQuery.onload = this.SendReportComplete;
     this.SendReportQuery.open( "POST", querystring,true);
     this.SendReportQuery.send( xml_doc );
     
     	  
  };
  
  this.SendReportComplete = function (){
	  
  };
}

////////////////////////////////////////////////////////////////////////////////
// helper functions
function iTrustPageQuery(uri){
   // TODO: THIS SHOULD BE ASYNC
   // Parse url
   var tags = encodeURI ( uri );

   // Query iTrustPage
   var iTrustPageQuery = new XMLHttpRequest();

   var querystring = "http://www.itrustpage.com/check?q="+tags;   
//   var useragent = iTrustPageQuery.getRequestHeader("User-Agent")+"; iTrustPage 1.0";

   iTrustPageQuery.open( "GET", querystring,false,"","" );
//   iTrustPageQuery.setRequestHeader( "User-Agent", "Mozilla/4.0 (compatible; iTrustPage 1.0; Windows XP 5.1)" );
//   iTrustPageQuery.setRequestHeader( "User-Agent", useragent);
   iTrustPageQuery.send( null );

   var response = iTrustPageQuery.responseText;
//   alert(response);
       
   return 1;
}
